//
//   摜IuWFNg DIB.cpp
//      by g0307 2003
//

#include "stdafx.h"
#include "DIB.h"
#include <math.h>

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

CDIB::CDIB()
:lpBMP(NULL)
{

}

CDIB::~CDIB()
{

}

dib_t CDIB::get_cubic_pixel(float x, float y)
{
	dib_t ret(0,0,0);
	int i, cx[16], cy[16];
	float dx, dy, fx, fy, w, r, g, b;

	// Cubic⊮̏ꍇPU_Kvł
	//   (ڂ͒F摜F_ pp.29Q)
	// 4ߖT
	cx[0] = int(x);cy[0] = int(y);
	cx[1] = cx[0] + 1;cy[1] = cy[0];
	cx[2] = cx[0];    cy[2] = cy[0] + 1;
	cx[3] = cx[0] + 1;cy[3] = cy[0] + 1;
	// 16ߖT
	cx[4]  = cx[0] - 1;cy[4]  = cy[0] - 1;
	cx[5]  = cx[0] - 1;cy[5]  = cy[0] + 0;
	cx[6]  = cx[0] - 1;cy[6]  = cy[0] + 1;
	cx[7]  = cx[0] - 1;cy[7]  = cy[0] + 2;
	cx[8]  = cx[0] + 0;cy[8]  = cy[0] - 1;
	cx[9]  = cx[0] + 0;cy[9]  = cy[0] + 2;
	cx[10] = cx[0] + 1;cy[10] = cy[0] - 1;
	cx[11] = cx[0] + 1;cy[11] = cy[0] + 2;
	cx[12] = cx[0] + 2;cy[12] = cy[0] - 1;
	cx[13] = cx[0] + 2;cy[13] = cy[0] + 0;
	cx[14] = cx[0] + 2;cy[14] = cy[0] + 1;
	cx[15] = cx[0] + 2;cy[15] = cy[0] + 2;
	// ݍ݌vZ
	r = g = b = 0;
	for( i = 0; i < 16; i++){

		dx = fabs(cx[i] - x);
		if(dx <= 1){
			fx = 1 - 2 * dx * dx + dx * dx * dx;
		} else if(dx <= 2) {
			fx = 4 - 8 * dx + 5 * dx * dx - dx * dx * dx;
		} else fx = 0;
		dy = fabs(cy[i] - y);
		if(dy <= 1){
			fy = 1 - 2 * dy * dy + dy * dy * dy;
		} else if(dy <= 2) {
			fy = 4 - 8 * dy + 5 * dy * dy - dy * dy * dy;
		} else fy = 0;

		// d݂Z
		w = fx * fy;
		if(cx[i] < 0)cx[i]=-cx[i];
		if(cy[i] < 0)cy[i]=-cy[i];
		if(cx[i] >= width)cx[i]= width + width - cx[i] - 1;
		if(cy[i] >= height)cy[i]= height + height - cy[i] - 1;

		r += at(cx[i], cy[i])->r * w;
		g += at(cx[i], cy[i])->g * w;
		b += at(cx[i], cy[i])->b * w;

	};//i

	// Pxl[0-255]͈̔͂ɂ
	r = max(0, r);r = min(255, r);
	g = max(0, g);g = min(255, g);
	b = max(0, b);b = min(255, b);
	//ʂ̑
	ret = dib_t(r,g,b);

	return ret;
}

bool CDIB::read(CDC *pDC, LPSTR filename)
{

	HDC hDC = pDC->GetSafeHdc();
	//rbg}bvt@C̓ǂݍ
	HANDLE hF;
	DWORD dwResult;

	hF = CreateFile(filename, GENERIC_READ, 0, 
		NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL,
        NULL);
	if(hF==INVALID_HANDLE_VALUE){
		return false;
	}
	//rbg}bvt@Cwb_[ǂݍ
	ReadFile(hF, &BmpFileH, sizeof(BITMAPFILEHEADER),&dwResult, NULL);
	//rbg}bvCtHwb_[ǂݍ
	ReadFile(hF, &BmpInfoH, sizeof(BITMAPINFOHEADER),&dwResult, NULL);
	//@rbg}bv̕߂
	width=BmpInfoH.biWidth;
	height=BmpInfoH.biHeight;
	// sb`(1C̃oCg)߂
	int band = 3;
	bool f24 = false;
	pitch = (width * band + band) & ~band;

	//24rbgt@Cǂׂ
	if(BmpInfoH.biBitCount == 24 )
	{
		f24 = true;
		BmpInfo.bmiHeader = BmpInfoH;
	}else if (BmpInfoH.biBitCount == 8){
		BmpInfo.bmiHeader = BmpInfoH;
		BmpInfoH.biBitCount = 24;
		BmpInfoH.biSizeImage *= 3;
		BmpInfo.bmiHeader.biBitCount = 24;
		BmpInfo.bmiHeader.biSizeImage *= 3;
	}
	//rbg}bvf[^܂Ńt@C|Cgړ
	SetFilePointer(hF, BmpFileH.bfOffBits, 0, FILE_BEGIN);

	//KvDIB̈쐬
	CreateDIBSection(hDC, &BmpInfo, DIB_RGB_COLORS, (VOID**)(&lpBMP),NULL,0);

	//rbg}bvf[^ǂݍ
	int h;
	if(f24)
	{
		for(h = 0; h < height;h++)
			ReadFile(hF, &lpBMP[pitch * (height - h - 1)], pitch, &dwResult, NULL);
	}else {
		for(h = 0; h < height;h++){
			char line[1024];
			ReadFile(hF, line, width, &dwResult, NULL);
			for(int w=0;w<width;w++){
				lpBMP[pitch * (height - h - 1)+ w * 3]   = line[w]; 
				lpBMP[pitch * (height - h - 1)+ w * 3+1] = line[w]; 
				lpBMP[pitch * (height - h - 1)+ w * 3+2] = line[w]; 
			}
		}
	}


	BmpInfo.bmiHeader.biHeight = -height;

	CloseHandle(hF);

	return true;
}

void CDIB::draw(CDC *pDC, int x, int y)
{

	HDC hdc = pDC->GetSafeHdc();
	StretchDIBits(hdc, x,y,width,height,0,0,width,height, 
				  lpBMP, &BmpInfo, DIB_RGB_COLORS, SRCCOPY);
}

//////////////////////////////////////////////////////////////////////
// DIB NX
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

//
//  sNZf[^Ԃ
//
dib_t * CDIB::at(int x, int y)
{
	return (dib_t*)&lpBMP[pitch * y + 3 * x];
}
//
//  摜f[^̃Rs[
//
void CDIB::copy(CDIB &src, dib_t key)
{
	int x, y;
	dib_t * dist_p, *src_p;

	// 摜̃TCY[v
	for(y = 0; y < height; y++){
		for(x = 0; x < width; x++){
			//]srcC]dist(x,y)̉f擾
			src_p = src.at(x, y);
			dist_p = at(x, y);
			//]f̐FߐFƈقȂΓ]
			if(*src_p != key)
				*dist_p = *src_p;
		};// x
	};//y
}


void CDIB::decompose3(gray_t &r, gray_t &g, gray_t &b)
{

	int x, y;
	
	r.resize(width, height);
	g.resize(width, height);
	b.resize(width, height);
	
	for(y = 0; y < height; y++){
		for(x = 0 ;x <width; x++){
			*r.at(x, y) = at(x,y)->r;
			*g.at(x, y) = at(x,y)->g;
			*b.at(x, y) = at(x,y)->b;
		};//x
	};//y

}

void CDIB::compose3(const gray_t &r, const gray_t &g, const gray_t &b)
{
	int x, y;
	float pr, pg, pb;

	for(y = 0; y < height; y++){
		for(x = 0 ;x <width; x++){
			pr = *r.at(x, y);
			pg = *g.at(x, y);
			pb = *b.at(x, y);
			// NbsO
			pr = max(pr, 0);pr = min(pr, 255);
			pg = max(pg, 0);pg = min(pg, 255);
			pb = max(pb, 0);pb = min(pb, 255);
			*at(x,y) = dib_t(pr, pg, pb); 
		};//x
	};//y
}

void CDIB::write(LPSTR filename)
{
	//rbg}bvt@C̓ǂݍ
	HANDLE hF;
	DWORD dwResult;

	hF = CreateFile(filename, GENERIC_WRITE, 0, 
		NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL,
        NULL);
	//rbg}bvt@Cwb_[ǂݍ
	WriteFile(hF, &BmpFileH, sizeof(BITMAPFILEHEADER),&dwResult, NULL);
	//rbg}bvCtHwb_[ǂݍ
	WriteFile(hF, &BmpInfoH, sizeof(BITMAPINFOHEADER),&dwResult, NULL);
	//rbg}bvf[^܂Ńt@C|Cgړ
	SetFilePointer(hF, BmpFileH.bfOffBits, 0, FILE_BEGIN);
	//rbg}bvf[^
	int h;
	for(h = 0; h < height;h++)
		WriteFile(hF, &lpBMP[pitch * h/*(height - h - 1)*/], pitch, &dwResult, NULL);

	DWORD tk = ::GetTickCount();
	WriteFile(hF, &tk, sizeof(DWORD), &dwResult, NULL);


	CloseHandle(hF);

}

void CDIB::resize(int w, int h)
{

	//@rbg}bv̕߂
	width= w;
	height= h;
	// sb`(1C̃oCg)߂
	pitch = (width * 3 + 3) & ~3;

	memset(&BmpInfo, 0, sizeof(BmpInfo));
	BmpInfo.bmiHeader.biHeight = -h;
	BmpInfo.bmiHeader.biWidth = w;
	BmpInfo.bmiHeader.biSize = 40;
	BmpInfo.bmiHeader.biSizeImage = pitch * h;
	BmpInfo.bmiHeader.biPlanes = 1;
	BmpInfo.bmiHeader.biBitCount = 24;
	BmpInfo.bmiHeader.biCompression  = 0;
	BmpInfo.bmiHeader.biClrUsed = 0;
	BmpInfo.bmiHeader.biXPelsPerMeter = 11811;
	BmpInfo.bmiHeader.biYPelsPerMeter = 11811;
	BmpInfo.bmiHeader.biClrImportant = 0;
	BmpInfoH = BmpInfo.bmiHeader;
	BmpFileH.bfOffBits = 54;
	BmpFileH.bfSize = pitch * h + 54;
	BmpFileH.bfType = 19778;


	if(lpBMP)delete lpBMP;
	lpBMP = new BYTE[pitch * h];
	
}
