// MainView.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "srederer_wnd.h"
#include "MainView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainView

IMPLEMENT_DYNCREATE(CMainView, CMiniFrameWnd)

CMainView::CMainView()
{
	fSettingRendering = fBuiltOctree = false;
}

CMainView::~CMainView()
{
}


BEGIN_MESSAGE_MAP(CMainView, CMiniFrameWnd)
	//{{AFX_MSG_MAP(CMainView)
	ON_WM_CREATE()
	ON_WM_PAINT()
	ON_WM_LBUTTONDOWN()
	ON_WM_MOUSEMOVE()
	ON_WM_RBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_RBUTTONUP()
	ON_COMMAND(ID_SAVEVIEW, OnSaveview)
	ON_COMMAND(ID_LOADVIEW, OnLoadview)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMainView bZ[W nh

int CMainView::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CMiniFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
		
	return 0;
}

//*****************************************
//   1-pXvZ
//*****************************************
bool CMainView::rendering()
{
	CDC *pDC=GetDC();
	//********************************************
	//    _O 
	//********************************************
	FLOAT lum = 10000.0;

	Ray ray;
	FLOAT rx, ry, fx, fy;
	D3DXVECTOR3 x, v, p;
	D3DXVECTOR3 camera_pos, look_at;
	FLOAT Focus;
	D3DXVECTOR3 e1, e2, e3;
	Color color, zero(0.0f, 0.0f, 0.0f);
	int tx, ty;

	camera_pos = m_pTracer->cam.pos;
	look_at = m_pTracer->cam.look_at;
	e1 = m_pTracer->cam.ex;
	e2 = m_pTracer->cam.ey;
	e3 = m_pTracer->cam.ez;
	Focus = m_pTracer->cam.Focus;

	//
	FLOAT scale = 1.0f / min(width, height);
	FLOAT white = 0.9 * 0.9, r, g, b;		
	
	for(ry = 0;ry < height;ry ++){
		for(rx = 0;rx < width;rx ++){
			color = zero;
			fx = rx + sub_x + rng.random() * sub_step;
			fy = ry + sub_y + rng.random() * sub_step;
			// eʂ̍W
			p = (D3DXVECTOR3)(((fx - width/2.0f) * scale) * e1 + ((fy - height/2.0f) * scale) * e2 + e3 * Focus);
			D3DXVec3Normalize(&p, &p);
			// ΂C쐬
			ray.x = camera_pos;
			ray.v = p;
			m_pTracer->depth = m_pTracer->refract_depth = 0;
			ray.ignor_light = false;
			// Փ˔ƐF̌vZ
			bool fEmitt;
			color = m_pTracer->trace(ray, fEmitt);
			*dR.at(rx, ry) += color.x;
			*dG.at(rx, ry) += color.y;
			*dB.at(rx, ry) += color.z;
		};//rx
		if( (int)ry % 40 == 0){	
			//****************************************
			//              \
			//****************************************
			for(ty = max(ry - 40, 0);ty < ry;ty ++){
				for(tx = 0;tx < width;tx ++){
					r = *dR.at(tx, ty) / iteration;
					g = *dG.at(tx, ty) / iteration;
					b = *dB.at(tx, ty) / iteration;
					r = r * (1 + r / white) / (1 + r);
					g = g * (1 + g / white) / (1 + g);
					b = b * (1 + b / white) / (1 + b);
					*pR.at(tx, ty) = lum * r;
					*pG.at(tx, ty) = lum * g;
					*pB.at(tx, ty) = lum * b;
				};//rx
			};//ry
			for(tx = 0;tx < width;tx ++){
				*pR.at(tx, ty) = 255;
				*pG.at(tx, ty) = 255;
				*pB.at(tx, ty) = 0;
			};//rx
			dib.compose3(pR, pG, pB);
			dib.draw(pDC, 0, 0);
		};
	};//ry
	//****************************************
	//              \
	//****************************************
	for(ty = max(ry - 40, 0);ty < ry;ty ++){
		for(tx = 0;tx < width;tx ++){
			r = *dR.at(tx, ty) / iteration;
			g = *dG.at(tx, ty) / iteration;
			b = *dB.at(tx, ty) / iteration;
			r = r * (1 + r / white) / (1 + r);
			g = g * (1 + g / white) / (1 + g);
			b = b * (1 + b / white) / (1 + b);
			*pR.at(tx, ty) = lum * r;
			*pG.at(tx, ty) = lum * g;
			*pB.at(tx, ty) = lum * b;
		};//rx
	};//ry
	
	dib.compose3(pR, pG, pB);
	dib.draw(pDC, 0, 0);
	
	char title[256];
	sprintf(title, "path = %d / %d", int(iteration), int(max_iteration));
	SetWindowText(title);
	
	iteration++;
	sub_x = sub_x + sub_step;
	if(sub_x >= 1){
		sub_x = 0.0;
		sub_y = sub_y + sub_step;
	};
	//**********************************
	//  pfmt@Cɏo
	//**********************************
	if(iteration % 16 == 0){
		char filename[256];
//		sprintf(filename, "./out/path_trace_%.2f_%d.pfm", m_pTracer->m_sss_scale, iteration);
		sprintf(filename, "./out/path_trace_%d.pfm", iteration);
		write_pfm(filename, dR, dG, dB, iteration);	
	};
	//**************************************
	ReleaseDC(pDC);

	if(iteration > max_iteration)
		return true;

	return false;
}

void CMainView::init_dib(int w, int h)
{
	width  = w;
	height = h;
	scale = min(width, height);
	dib.resize(width, height);
	dib.decompose3(dR, dG, dB);
	pR = dR;
	pG = dG;
	pB = dB;
	draw_frame();
	fSettingRendering = fBuiltOctree = false;
}

void CMainView::OnPaint() 
{
	CPaintDC dc(this);

	dib.draw(&dc, 0, 0);
}

void CMainView::draw_frame()
{
	int x, y;
	int i;
	D3DXVECTOR3 p1, p2, p3, v1, v2, v3;
	D3DXVECTOR3 x1,x2,x3;
	CPoint dps[4];

	for(y = 0; y < height;y++){
		for(x = 0; x < width;x++){
			*dR.at(x, y) = 255;
		};//x
	};//y
	for(i = 0; i < m_pTracer->triangles.size(); i++){
		v1 = m_pTracer->triangles[i]->x1;
		v2 = m_pTracer->triangles[i]->x2;
		v3 = m_pTracer->triangles[i]->x3;
		// JWnɕϊ
		m_pTracer->cam.trans_perspect(v1, p1);
		m_pTracer->cam.trans_perspect(v2, p2);
		m_pTracer->cam.trans_perspect(v3, p3);
		// `
		if(p1.z > 0.2 && p2.z > 0.2 && p3.z > 0.2){
			dps[0].x = p1.x * scale + width / 2;
			dps[0].y = p1.y * scale + height / 2;
			dps[1].x = p2.x * scale + width / 2;
			dps[1].y = p2.y * scale + height / 2;
			dps[2].x = p3.x * scale + width / 2;
			dps[2].y = p3.y * scale + height / 2;
			line(dR, dps[0].x, dps[0].y, dps[1].x, dps[1].y);
			line(dR, dps[1].x, dps[1].y, dps[2].x, dps[2].y);
			line(dR, dps[0].x, dps[0].y, dps[2].x, dps[2].y);
		};
	};	
	dib.compose3(dR, dR, dR);
	set_title();
	RedrawWindow();
	fSettingRendering = false;
}

/************************************
* @@u[ñASY
***********************************/
void CMainView::line(gray_t & img, int x1,int y1,int x2,int y2){
	
	int px;  //݁A_łĂW
	int py;
	
	int counter = 0;  //JE^
	
	int dstX;  //n_I_܂ł̋
	int dstY;
	
	int addX;  //
	int addY;
	
	//n_I_܂ł́Ax,yꂼ̋߂
	dstX = x2 - x1;
	if(dstX < 0){
		dstX *= -1;  //0ȉȂ畄]
		addX = -1;
	}
	else{
		addX = 1;
	}
	
	dstY = y2 - y1;
	if(dstY < 0){
		dstY *= -1;  //0ȉȂ畄]
		addY = -1;
	}
	else{
		addY = 1;
	}
	
	px = x1;  //(x1,y1)̈ʒun߂
	py = y1;
	
	//r
	if(dstX > dstY){
		// Xɓ_łĂ
		for(int i=0;i<dstX;i++){
			if(px>0 && px<img.width && py>0 && py<img.height){
				*img.at(px, py) = 0;
				counter += dstY;
				if(counter > dstX){
					counter -= dstX;
					py += addY;
				}
			}
			px += addX;
		}
	}
	else{
		// Yɓ_łĂ
		for(int i=0;i<dstY;i++){
			if(px>0 && px<img.width && py>0 && py<img.height){
				*img.at(px, py) = 0;
				counter += dstX;
				if(counter > dstY){
					counter -= dstY;
					px += addX;
				}
			}
			py += addY;
		}
	}
	
}

// EBhE^Cgݒ
void CMainView::set_title()
{
	char buf[1024];
	sprintf(buf, "%d x % d:  %d triangles", width, height, m_pTracer->triangles.size());
	SetWindowText(buf);
}

void CMainView::SettingRendering()
{
	if(!fBuiltOctree){
		m_pTracer->build_octree();
		m_pTracer->build_light_density();
		m_pTracer->set_ibl("./ibl/grace_probe.pfm");
		m_pTracer->set_EIHDRI("./ibl/grace.txt");
		fBuiltOctree = true;
	};

	if(fSettingRendering)
		return;

	int rx, ry;
	for(ry = 0;ry < height;ry ++){
		for(rx = 0;rx < width;rx ++){
			*dR.at(rx, ry) = *dG.at(rx, ry) = *dB.at(rx, ry) = 0.0f;
		};//rx
	};//ry

	sample_num = 40;
	max_iteration = sample_num * sample_num;
	sub_step = 1.0f / (sample_num);
	sub_x = sub_y = 0.0;
	iteration = 1;

	fSettingRendering = true;
}

void CMainView::write_pfm(LPSTR filename, gray_t &R, gray_t &G, gray_t &B, FLOAT num)
{

	int x, y;
	FLOAT rgb[3];

	FILE * fp = fopen(filename, "wb");
	fprintf(fp, "PF\n%d\n%d\n-1.000000\n", (int)width, (int)height);
	for(y = height - 1; y >= 0; y--){
		for(x = 0; x < width; x++){
			rgb[0] = *R.at(x,y) / num;
			rgb[1] = *G.at(x,y) / num;
			rgb[2] = *B.at(x,y) / num;
			fwrite(rgb, sizeof(FLOAT), 3, fp);
		};//
	};//y
	fclose(fp);
}

void CMainView::OnLButtonDown(UINT nFlags, CPoint point) 
{
	mouse_mode = MOUSEMODE_LEFT;
	last_point = click_point = point;
	
	CMiniFrameWnd::OnLButtonDown(nFlags, point);
}

void CMainView::OnMouseMove(UINT nFlags, CPoint point) 
{
	FLOAT dx = last_point.x - point.x;
	FLOAT dy = last_point.y - point.y;
	FLOAT d = sqrt(dx*dx+dy*dy);
	FLOAT step;

	if(mouse_mode == MOUSEMODE_RIGHT && d > 10.0){

		step = (point.y - last_point.y) / 20.0;
		if(step > 10.0)step=10.0;
		if(step < -10.0)step=-10.0;

		m_pTracer->cam.trans_ez(step);
		draw_frame();

		last_point = point;

	} else if(mouse_mode == MOUSEMODE_LEFT && d > 3.0){

		FLOAT step_x, step_y;
		step_x = (point.x - last_point.x) / 50.0;
		step_y = (point.y - last_point.y) / 50.0;

		if(nFlags & MK_CONTROL){
			m_pTracer->cam.pos -= (m_pTracer->cam.ex * step_x) * 3;
			m_pTracer->cam.pos -= (m_pTracer->cam.ey * step_y) * 3;
		} else {
			if(fabs(step_x) > fabs(step_y)){
				if(step_x > 1.0)step_x =1.0;
				if(step_x < -1.0)step_x =-1.0;
				m_pTracer->cam.turn_left(-step_x);
			} else {
				if(step_y > 1.0)step_y =1.0;
				if(step_y < -1.0)step_y =-1.0;
				m_pTracer->cam.turn_top(-step_y);
			};
		};
		draw_frame();

		last_point = point;

	};
	
	CMiniFrameWnd::OnMouseMove(nFlags, point);
}

void CMainView::OnRButtonDown(UINT nFlags, CPoint point) 
{
	mouse_mode = MOUSEMODE_RIGHT;
	last_point = click_point = point;
	
	CMiniFrameWnd::OnRButtonDown(nFlags, point);
}

void CMainView::OnLButtonUp(UINT nFlags, CPoint point) 
{
	mouse_mode = 0;	
	CMiniFrameWnd::OnLButtonUp(nFlags, point);
}

void CMainView::OnRButtonUp(UINT nFlags, CPoint point) 
{
	mouse_mode = 0;	
	CMiniFrameWnd::OnRButtonUp(nFlags, point);
}

void CMainView::OnSaveview() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	
}

void CMainView::OnLoadview() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	
}
