//
// J̃NX
//

#ifndef _CAMERA_
#define _CAMERA_	1

//
// JIuWFNg
//
class camera {

public:

	camera(){
		upper = D3DXVECTOR3(0.0f, 1.0f, 0.0f);
		pos   = D3DXVECTOR3(0.0f, 0.0f, 0.0f);
		look_at = D3DXVECTOR3(0.0f, 0.0f, 1.0f);
		Focus = 1.0f;
		w = 320;
		h = 240;
	};	

	void init_camera(D3DXVECTOR3 _pos, D3DXVECTOR3 _look_at, FLOAT _focus){
		pos = _pos;
		look_at = _look_at;
		Focus = _focus;
		init_orthogonal();
	};
	//**************************************************************
	// Jʒuƒړ_Ɛ^xNg璼snxNge1, e2, e3쐬
	//**************************************************************
	void init_orthogonal(){
		ez = look_at - pos;
		D3DXVec3Normalize(&ez, &ez);
		D3DXVECTOR3 bx, by;
		two_tangent_vector(ez, bx, by);
		ey = bx * D3DXVec3Dot(&bx, &upper) +  by * D3DXVec3Dot(&by, &upper);
		D3DXVec3Normalize(&ey, &ey);
		D3DXVec3Cross(&ex, &ey, &ez);
		D3DXVec3Normalize(&ex, &ex);
	};
	//***********************************************************
	// @xNg璼̐ڃxNgbx, byvZ
	//***********************************************************
	void two_tangent_vector(const D3DXVECTOR3 &n, D3DXVECTOR3 &bx, D3DXVECTOR3 &by)
	{
		FLOAT e1,e2,e3, min;
		e1 = fabs(n.x);
		e2 = fabs(n.y);
		e3 = fabs(n.z);
		min = min(e1, min(e2, e3));
		
		if (min == e1) {
			bx.x =  0.0;
			bx.y = -n.z;
			bx.z =  n.y;
		} else if (min == e2) {
			bx.x = -n.z;
			bx.y =  0.0;
			bx.z =  n.x;
		} else if (min == e3) {
			bx.x = -n.y;
			bx.y =  n.x;
			bx.z =  0.0;
		}
		D3DXVec3Normalize(&bx, &bx);
		D3DXVec3Cross(&by, &bx, &n);
		D3DXVec3Normalize(&by, &by);
		
	};

	void trans_perspect(const D3DXVECTOR3 & v, D3DXVECTOR3 & p){

		D3DXVECTOR3 dp;
		dp = v - pos;

		p.x = D3DXVec3Dot(&dp, &ex);
		p.y = D3DXVec3Dot(&dp, &ey);
		p.z = D3DXVec3Dot(&dp, &ez);
		// ˉeϊ
//		p.x = Focus * p.x / (p.z + Focus);
//		p.y = Focus * p.y / (p.z + Focus);
		p.x = Focus * p.x / (p.z);
		p.y = Focus * p.y / (p.z);
	};//

	// ɉ]
	void turn_left(FLOAT angle){

		D3DXMATRIX R;
		D3DXMatrixIdentity(&R);
		/*
		D3DXMatrixRotationY(&R, angle);
		*/
		D3DXQUATERNION qt; //]NH[^jI
		D3DXVECTOR3 v = ey; //ƂȂxNg
		qt.x = qt.y = qt.z = 0;qt.w = 1.0f;  //PʃNH[^jIɏ
		D3DXQuaternionRotationAxis(&qt, &v, angle); //NH[^jI]
		D3DXMatrixRotationQuaternion(&R, &qt); //NH[^jǏvZss쐬
		D3DXVec3TransformCoord(&ex, &ex, &R);
		D3DXVec3TransformCoord(&ey, &ey, &R);
		D3DXVec3TransformCoord(&ez, &ez, &R);


	};
	// ɉ]
	void turn_top(FLOAT angle){
		/*
		D3DXMATRIX R;
		D3DXMatrixIdentity(&R);
		D3DXMatrixRotationX(&R, angle);
		D3DXVec3TransformCoord(&ex, &ex, &R);
		D3DXVec3TransformCoord(&ey, &ey, &R);
		D3DXVec3TransformCoord(&ez, &ez, &R);
		*/
		D3DXMATRIX R;
		D3DXMatrixIdentity(&R);
		D3DXQUATERNION qt; //]NH[^jI
		D3DXVECTOR3 v = ex; //ƂȂxNg
		qt.x = qt.y = qt.z = 0;qt.w = 1.0f;  //PʃNH[^jIɏ
		D3DXQuaternionRotationAxis(&qt, &v, angle); //NH[^jI]
		D3DXMatrixRotationQuaternion(&R, &qt); //NH[^jǏvZss쐬
		D3DXVec3TransformCoord(&ex, &ex, &R);
		D3DXVec3TransformCoord(&ey, &ey, &R);
		D3DXVec3TransformCoord(&ez, &ez, &R);


	};

	void trans_ez(FLOAT d)
	{
		pos = pos + ez * d;
	};

	D3DXVECTOR3 upper;
	D3DXVECTOR3 pos, look_at;
	FLOAT Focus;
	D3DXVECTOR3 ex, ey, ez;
	int w, h;
};


#endif