//***********************************************************
// INc[̃NX by g0307 2006
//***********************************************************

#ifndef __OCTREE__
#define __OCTREE__


#include "s_triangle.h"

//*********************
// INc[m[hf[^
//*********************
struct oct_node {
	

     inline
     unsigned int choose_next(FLOAT x, FLOAT y, FLOAT z,
                              unsigned int a, unsigned int b, unsigned int c)
     {
         if(x < y) {
             if(x < z) return a;
             else return c;
         } else {
             if(y < z) return b;
             else return c;
         }
     }

	//*********************************************
	// oϐ
	//*********************************************
	D3DXVECTOR3 min_pt, max_pt; //{NZW
	D3DXVECTOR3 center_pt;      //{NZS
	bool fLeaf;					//[̃m[hǂ
	int depth;

	//qm[h
	oct_node *pChild[8];
	// |S̃|C^
	ptriangles_t objects;
	//*********************************************
	//  evV[W
	//*********************************************
	void clear()
	{
		int i;
		objects.clear();
		for(i = 0; i < 8;i++)
			if(pChild[i]){
				pChild[i]->clear();
				delete pChild[i];
				pChild[i] = NULL;
			};
	};
	//|C^
	void init(){
		int i;
		for(i = 0; i < 8;i++)
			pChild[i] = NULL;
	};
	// RXgN^
	oct_node(){
		init();
		fLeaf = false;
	}
	~oct_node(){
		clear();
	};
	oct_node(D3DXVECTOR3 & _min_pt, D3DXVECTOR3 & _max_pt)
	{
		init();
		min_pt = _min_pt;
		max_pt = _max_pt;
		center_pt = (min_pt + max_pt) * 0.5;
		fLeaf = false;
		depth = 0;
	};	
	//**************************************
	// INc[̍\z
	//**************************************
	void divide(){
		int i;
		
		fLeaf = false;

		D3DXVECTOR3 child_min_pt[8], child_max_pt[8];
		
		child_min_pt[0] = min_pt;
		child_max_pt[0] = center_pt;
		child_min_pt[1] = D3DXVECTOR3(   min_pt.x,    min_pt.y, center_pt.z);
		child_max_pt[1] = D3DXVECTOR3(center_pt.x, center_pt.y,    max_pt.z);
		child_min_pt[2] = D3DXVECTOR3(   min_pt.x, center_pt.y,    min_pt.z);
		child_max_pt[2] = D3DXVECTOR3(center_pt.x,    max_pt.y, center_pt.z);
		child_min_pt[3] = D3DXVECTOR3(   min_pt.x, center_pt.y, center_pt.z);
		child_max_pt[3] = D3DXVECTOR3(center_pt.x,    max_pt.y,    max_pt.z);
		child_min_pt[4] = D3DXVECTOR3(center_pt.x,    min_pt.y,    min_pt.z);
		child_max_pt[4] = D3DXVECTOR3(max_pt.x,    center_pt.y, center_pt.z);
		child_min_pt[5] = D3DXVECTOR3(center_pt.x,    min_pt.y, center_pt.z);
		child_max_pt[5] = D3DXVECTOR3(max_pt.x,    center_pt.y,    max_pt.z);
		child_min_pt[6] = D3DXVECTOR3(center_pt.x, center_pt.y,    min_pt.z);
		child_max_pt[6] = D3DXVECTOR3(max_pt.x,       max_pt.y, center_pt.z);
		child_min_pt[7] = center_pt;
		child_max_pt[7] = max_pt;
		
		// IuWFNg萔ȏȂΕ
		ptriangles_t newobjects;
			
		ptriangles_t::iterator t;
		for(i = 0; i < 8; i++){
			newobjects.clear();
			for(t = objects.begin(); t != objects.end(); t++){
				// ZɎOp`͂邩ǂ
				if(triangle_in_check(*(*t), child_min_pt[i], child_max_pt[i])){
					newobjects.push_back(*t);
				};//fi
			};//t
			// Vqm[h̍쐬
			oct_node * newTree = new oct_node(child_min_pt[i], child_max_pt[i]);
			newTree->depth = depth + 1;
			newTree->objects = newobjects;
			pChild[i] = newTree;
		};// i


		if(depth > 15){
			fLeaf = true;
			return;
		}
		if(objects.size() <= 10){
			fLeaf = true;
			return;
		}

		objects.clear();
		for(i = 0; i < 8; i++)
			pChild[i]->divide();
		
		
	};

	// Op`{NZɊ܂܂邩
	bool triangle_in_check(Triangle & tri, D3DXVECTOR3 & minp, D3DXVECTOR3 & maxp){


		// ܂AȒPȔiOp`̂P_܂܂Ă΂njj

		const EPSILON = 0.0001;
		bool ret = false;

		if(
		(tri.x1.x >= minp.x  && tri.x1.x <= maxp.x  && tri.x1.y >= minp.y  && tri.x1.y <= maxp.y  && tri.x1.z >= minp.z  && tri.x1.z <= maxp.z ) || 
		(tri.x2.x >= minp.x  && tri.x2.x <= maxp.x  && tri.x2.y >= minp.y  && tri.x2.y <= maxp.y  && tri.x2.z >= minp.z  && tri.x2.z <= maxp.z ) ||
		(tri.x3.x >= minp.x  && tri.x3.x <= maxp.x  && tri.x3.y >= minp.y  && tri.x3.y <= maxp.y  && tri.x3.z >= minp.z  && tri.x3.z <= maxp.z )
		)
		return true;

		/*
		D3DXVECTOR3 cp = (tri.x1 + tri.x2 + tri.x3) / 3.0f;
		if(triangle_in_check_line(cp, tri.x1, minp, maxp))
			return  true;
		if(triangle_in_check_line(cp, tri.x2, minp, maxp))
			return  true;
		if(triangle_in_check_line(cp, tri.x3, minp, maxp))
			return  true;
			*/

		/*
		// Op`̕ӂł邩H
		if(triangle_in_check_line(tri.x2, tri.x1, minp, maxp))
			return   true;
		if(triangle_in_check_line(tri.x3, tri.x1, minp, maxp))
			return  true;
		if(triangle_in_check_line(tri.x3, tri.x2, minp, maxp))
			return  true;
			*/

		/*
		D3DXVECTOR3 pc;
		for(double u = 0.0; u <= 1.0; u+=0.02){
			pc = tri.x2  * (1-u) + tri.x3 * u;
			if(triangle_in_check_line(pc, tri.x1, minp, maxp))
				return  true;
			pc = tri.x1  * (1-u) + tri.x3 * u;
			if(triangle_in_check_line(pc, tri.x2, minp, maxp))
				return  true;
			pc = tri.x1  * (1-u) + tri.x2 * u;
			if(triangle_in_check_line(pc, tri.x3, minp, maxp))
				return  true;
		};
		*/
		return fIntersect_box_triangle(tri.x1, tri.x2, tri.x3, minp, maxp);
		/*
		if(ret && !fIntersect_plane_triangle(tri.x1, tri.x2, tri.x3, minp, maxp)){
			fIntersect_plane_triangle(tri.x1, tri.x2, tri.x3, minp, maxp);
			return ret;
		};
		*/

		
		return false;
	};
	//*******************************************************************************
	//    {bNXɐ܂܂邩H
	//*******************************************************************************
	int triangle_in_check_line(D3DXVECTOR3 & v1, D3DXVECTOR3 & v2, D3DXVECTOR3 & minp, D3DXVECTOR3 & maxp)
	{
		D3DXVECTOR3 ;
		int ret = 0;
		FLOAT & x1 = minp.x, x2 = maxp.x;
		FLOAT & y1 = minp.y, y2 = maxp.y;
		FLOAT & z1 = minp.z, z2 = maxp.z;
		D3DXVECTOR3 ax, p1, p2, ip;
		FLOAT a;
		
		FLOAT t1, t2;
		FLOAT ex = (maxp.x - minp.x)*0.000001f;
		FLOAT ey = (maxp.y - minp.y)*0.000001f;
		FLOAT ez = (maxp.z - minp.z)*0.000001f;
		
		// xŔr
		t1 = v1.x;t2 = v2.x;
		if(t1 > t2){
			p1 = v2;p2 = v1;
			t1 = v2.x;t2 = v1.x;
		} else {
			p1 = v1;p2 = v2;
		}
		ax = p2 - p1;

		if(t2 >= x1 && t1 <= x2 && fabs(t1-t2) > 0.00000001f){
			if(x1 >= t1){
				a = (x1 - t1) / (t2 - t1);ip = p1 + a * ax;// x1̌_߂
				if(ip.y >= (y1-ey) && ip.y <= (y2+ey) && ip.z >= (z1-ez) && ip.z <= (z2+ez))//{bNXʏɂ邩ǂ
					return true;
			};
			if(t2 >= x2){
				a = (x2 - t1) / (t2 - t1);ip = p1 + a * ax;// x2̌_߂
				if(ip.y >= (y1-ey) && ip.y <= (y2+ey) && ip.z >= (z1-ez) && ip.z <= (z2+ez))//{bNXʏɂ邩ǂ
					return true;
			}
		};
		// yŔr
		t1 = v1.y;t2 = v2.y;
		if(t1 > t2){
			p1 = v2;p2 = v1;
			t1 = v2.y;t2 = v1.y;
		} else {
			p1 = v1;p2 = v2;
		}
		ax = p2 - p1;
		if(t2 >= y1 && t1 <= y2 && fabs(t1-t2) > 0.00000001f){	
		if(y1 >= t1){
			a = (y1 - t1) / (t2 - t1);ip = p1 + a * ax;// y1̌_߂
			if(ip.x >= (x1-ex) && ip.x <= (x2+ex)  && ip.z >= (z1-ez) && ip.z <= (z2+ez))//{bNXʏɂ邩ǂ
				return true;
		}
		if(t2 >= y2){
			a = (y2 - t1) / (t2 - t1);ip = p1 + a * ax;// y2̌_߂
			if(ip.x >= (x1-ex) && ip.x <= (x2+ex)  && ip.z >= (z1-ez) && ip.z <= (z2+ez))//{bNXʏɂ邩ǂ
				return true;
		};
		};
		// zŔr
		t1 = v1.z;t2 = v2.z;
		if(t1 > t2){
			p1 = v2;p2 = v1;
			t1 = v2.z;t2 = v1.z;
		} else {
			p1 = v1;p2 = v2;
		}
		ax = p2 - p1;
		if(( (t2 >= z1 && t1 <= z2)) && fabs(t1-t2) > 0.00000001f){
			if(z1 >= t1){
				a = (z1 - t1) / (t2 - t1);ip = p1 + a * ax;// z1̌_߂
				if(ip.x >= (x1-ex) && ip.x <= (x2+ex) && ip.y >= (y1-ey) && ip.y <= (y2+ey))//{bNXʏɂ邩ǂ
					return true;
			}
			if(t2 >= z2){
				a = (z2 - t1) / (t2 - t1);ip = p1 + a * ax;// z2̌_߂
				if(ip.x >= (x1-ex) && ip.x <= (x2+ex) && ip.y >= (y1-ey) && ip.y <= (y2+ey))//{bNXʏɂ邩ǂ
					return true;
			};
		}
		return false;
	};


	//*******************************************************************************
	//    {bNXƐƂ̌_߂
	//*******************************************************************************
	bool triangle_line_intersection(D3DXVECTOR3 & v1, D3DXVECTOR3 & v2, D3DXVECTOR3 & minp, D3DXVECTOR3 & maxp,
		std::vector<D3DXVECTOR3> & ipx1, std::vector<D3DXVECTOR3> & ipx2,
		std::vector<D3DXVECTOR3> & ipy1, std::vector<D3DXVECTOR3> & ipy2,
		std::vector<D3DXVECTOR3> & ipz1, std::vector<D3DXVECTOR3> & ipz2
		)
	{

		int ret = 0;
		FLOAT & x1 = minp.x, x2 = maxp.x;
		FLOAT & y1 = minp.y, y2 = maxp.y;
		FLOAT & z1 = minp.z, z2 = maxp.z;
		D3DXVECTOR3 ax, p1, p2, ip;
		FLOAT a;
		
		FLOAT t1, t2;
		FLOAT ex = (maxp.x - minp.x)*0.000001f;
		FLOAT ey = (maxp.y - minp.y)*0.000001f;
		FLOAT ez = (maxp.z - minp.z)*0.000001f;

		// xŔr
		t1 = v1.x;t2 = v2.x;
		if(t1 > t2){
			p1 = v2;p2 = v1;
			t1 = v2.x;t2 = v1.x;
		} else {
			p1 = v1;p2 = v2;
		}
		ax = p2 - p1;
	
		if(t2 >= x1 && t1 <= x2 && fabs(t1-t2) > 0.00000001f){
			if(x1 >= t1){
				a = (x1 - t1) / (t2 - t1);ip = p1 + a * ax;// x1̌_߂
				if(ip.y >= (y1-ey) && ip.y <= (y2+ey) && ip.z >= (z1-ez) && ip.z <= (z2+ez))//{bNXʏɂ邩ǂ
					return true;
				ipx1.push_back(ip);
			};
			if(t2 >= x2){
				a = (x2 - t1) / (t2 - t1);ip = p1 + a * ax;// x2̌_߂
				if(ip.y >= (y1-ey) && ip.y <= (y2+ey) && ip.z >= (z1-ez) && ip.z <= (z2+ez))//{bNXʏɂ邩ǂ
					return true;
				ipx2.push_back(ip);
			}
		};
		// yŔr
		t1 = v1.y;t2 = v2.y;
		if(t1 > t2){
			p1 = v2;p2 = v1;
			t1 = v2.y;t2 = v1.y;
		} else {
			p1 = v1;p2 = v2;
		}
		ax = p2 - p1;
		if(t2 >= y1 && t1 <= y2 && fabs(t1-t2) > 0.00000001f){	
		if(y1 >= t1){
			a = (y1 - t1) / (t2 - t1);ip = p1 + a * ax;// y1̌_߂
			if(ip.x >= (x1-ex) && ip.x <= (x2+ex)  && ip.z >= (z1-ez) && ip.z <= (z2+ez))//{bNXʏɂ邩ǂ
				return true;
			ipy1.push_back(ip);
		}
		if(t2 >= y2){
			a = (y2 - t1) / (t2 - t1);ip = p1 + a * ax;// y2̌_߂
			if(ip.x >= (x1-ex) && ip.x <= (x2+ex)  && ip.z >= (z1-ez) && ip.z <= (z2+ez))//{bNXʏɂ邩ǂ
				return true;
			ipy2.push_back(ip);
		};
		};
		// zŔr
		t1 = v1.z;t2 = v2.z;
		if(t1 > t2){
			p1 = v2;p2 = v1;
			t1 = v2.z;t2 = v1.z;
		} else {
			p1 = v1;p2 = v2;
		}
		ax = p2 - p1;
		if(( (t2 >= z1 && t1 <= z2)) && fabs(t1-t2) > 0.00000001f){
			if(z1 >= t1){
				a = (z1 - t1) / (t2 - t1);ip = p1 + a * ax;// z1̌_߂
				if(ip.x >= (x1-ex) && ip.x <= (x2+ex) && ip.y >= (y1-ey) && ip.y <= (y2+ey))//{bNXʏɂ邩ǂ
					return true;
				ipz1.push_back(ip);
			}
			if(t2 >= z2){
				a = (z2 - t1) / (t2 - t1);ip = p1 + a * ax;// z2̌_߂
				if(ip.x >= (x1-ex) && ip.x <= (x2+ex) && ip.y >= (y1-ey) && ip.y <= (y2+ey))//{bNXʏɂ邩ǂ
					return true;
				ipz2.push_back(ip);
			};
		}
		return false;
	};
	// Op`ƕʎlp`邩
	bool fIntersect_box_triangle(D3DXVECTOR3 & p1, D3DXVECTOR3 & p2, D3DXVECTOR3 & p3,
		D3DXVECTOR3 & minp, D3DXVECTOR3 & maxp){
		
		D3DXVECTOR3 tmin, tmax;

		// 3p`̃oEfBO{bNXł܂
		tmin.x = min(p1.x, min(p2.x, p3.x));
		tmin.y = min(p1.y, min(p2.y, p3.y));
		tmin.z = min(p1.z, min(p2.z, p3.z));
		tmax.x = max(p1.x, max(p2.x, p3.x));
		tmax.y = max(p1.y, max(p2.y, p3.y));
		tmax.z = max(p1.z, max(p2.z, p3.z));

		if(
			!((tmin.x < maxp.x && tmax.x > minp.x) &&
			(tmin.y < maxp.y && tmax.y > minp.y) &&
			(tmin.z < maxp.z && tmax.z > minp.z)) )
			return false;

		std::vector<D3DXVECTOR3> ipx1, ipx2;
		std::vector<D3DXVECTOR3> ipy1, ipy2;
		std::vector<D3DXVECTOR3> ipz1, ipz2;
		FLOAT a, d;
		int i, s;
		D3DXVECTOR3 ip, dp;

		ipx1.clear();ipx2.clear();
		ipy1.clear();ipy2.clear();
		ipz1.clear();ipz2.clear();

		if(triangle_line_intersection(p1, p2, minp, maxp, ipx1, ipx2, ipy1, ipy2, ipz1, ipz2))
			return true;
		if(triangle_line_intersection(p2, p3, minp, maxp, ipx1, ipx2, ipy1, ipy2, ipz1, ipz2))
			return true;
		if(triangle_line_intersection(p1, p3, minp, maxp, ipx1, ipx2, ipy1, ipy2, ipz1, ipz2))
			return true;

		// x1yzʂƂ̌_
		s = ipx1.size();
//		if(s==3)
//			return true;
		if(s>1){
			D3DXVECTOR3 & ip1 = ipx1[0];
			D3DXVECTOR3 & ip2 = ipx1[1];
			FLOAT z1 = minp.z;
			FLOAT z2 = maxp.z;
			FLOAT y1 = minp.y;
			FLOAT y2 = maxp.y;
			// yƂ̔
			if(ip1.z > ip2.z){
				std::swap(ip1, ip2);
			};
			dp = ip2 - ip1;
			a = (z1 - ip1.z) / (ip2.z - ip1.z);ip = ip1 + a * dp;
			if(a >= 0 && a <= 1 && ip.y >= y1 && ip.y <= y2)
				return true;
			a = (z2 - ip1.z) / (ip2.z - ip1.z);ip = ip1 + a * dp;
			if(a >= 0 && a <= 1 && ip.y >= y1 && ip.y <= y2)
				return true;
			// zƂ̔
			if(ip1.y > ip2.y){
				std::swap(ip1, ip2);
			};
			dp = ip2 - ip1;
			a = (y1 - ip1.y) / (ip2.y - ip1.y);ip = ip1 + a * dp;
			if(a >= 0 && a <= 1 && ip.z >= z1 && ip.z <= z2)
				return true;
			a = (y2 - ip1.y) / (ip2.y - ip1.y);ip = ip1 + a * dp;
			if(a >= 0 && a <= 1 && ip.z >= z1 && ip.z <= z2)
				return true;
		};
		// x2yzʂƂ̌_
		s = ipx2.size();
//		if(s==3)
//			return true;
		if(s >1){
			D3DXVECTOR3 & ip1 = ipx2[0];
			D3DXVECTOR3 & ip2 = ipx2[1];
			FLOAT z1 = minp.z;
			FLOAT z2 = maxp.z;
			FLOAT y1 = minp.y;
			FLOAT y2 = maxp.y;
			// yƂ̔
			if(ip1.z > ip2.z){
				std::swap(ip1, ip2);
			};
			dp = ip2 - ip1;
			a = (z1 - ip1.z) / (ip2.z - ip1.z);ip = ip1 + a * dp;
			if(a >= 0 && a <= 1 && ip.y >= y1 && ip.y <= y2)
				return true;
			a = (z2 - ip1.z) / (ip2.z - ip1.z);ip = ip1 + a * dp;
			if(a >= 0 && a <= 1 && ip.y >= y1 && ip.y <= y2)
				return true;
			// zƂ̔
			if(ip1.y > ip2.y){
				std::swap(ip1, ip2);
			};
			dp = ip2 - ip1;
			a = (y1 - ip1.y) / (ip2.y - ip1.y);ip = ip1 + a * dp;
			if(a >= 0 && a <= 1 && ip.z >= z1 && ip.z <= z2)
				return true;
			a = (y2 - ip1.y) / (ip2.y - ip1.y);ip = ip1 + a * dp;
			if(a >= 0 && a <= 1 && ip.z >= z1 && ip.z <= z2)
				return true;
		};
		// y1xzʂƂ̌_
		s = ipy1.size();
//		if(s==3)
//			return true;
		if(s > 1){
			D3DXVECTOR3 & ip1 = ipy1[0];
			D3DXVECTOR3 & ip2 = ipy1[1];
			FLOAT z1 = minp.z;
			FLOAT z2 = maxp.z;
			FLOAT x1 = minp.x;
			FLOAT x2 = maxp.x;
			// xƂ̔
			if(ip1.z > ip2.z){
				std::swap(ip1, ip2);
			};
			dp = ip2 - ip1;
			a = (z1 - ip1.z) / (ip2.z - ip1.z);ip = ip1 + a * dp;
			if(a >= 0 && a <= 1 && ip.x >= x1 && ip.x <= x2)
				return true;
			a = (z2 - ip1.z) / (ip2.z - ip1.z);ip = ip1 + a * dp;if(a >= 0 && a <= 1 && ip.x >= x1 && ip.x <= x2)
				return true;
			// zƂ̔
			if(ip1.x > ip2.x){
				std::swap(ip1, ip2);
			};
			dp = ip2 - ip1;
			a = (x1 - ip1.x) / (ip2.x - ip1.x);ip = ip1 + a * dp;
			if(a >= 0 && a <= 1 && ip.z >= z1 && ip.z <= z2)
				return true;
			a = (x2 - ip1.x) / (ip2.x - ip1.x);ip = ip1 + a * dp;
			if(a >= 0 && a <= 1 && ip.z >= z1 && ip.z <= z2)
				return true;
		};
		// y2xzʂƂ̌_
		s = ipy2.size();
//		if(s==3)
//			return true;
		if(s>1){
			D3DXVECTOR3 & ip1 = ipy2[0];
			D3DXVECTOR3 & ip2 = ipy2[1];
			FLOAT z1 = minp.z;
			FLOAT z2 = maxp.z;
			FLOAT x1 = minp.x;
			FLOAT x2 = maxp.x;
			// xƂ̔
			if(ip1.z > ip2.z){
				std::swap(ip1, ip2);
			};
			dp = ip2 - ip1;
			a = (z1 - ip1.z) / (ip2.z - ip1.z);ip = ip1 + a * dp;
			if(a >= 0 && a <= 1 && ip.x >= x1 && ip.x <= x2)
				return true;
			a = (z2 - ip1.z) / (ip2.z - ip1.z);ip = ip1 + a * dp;if(a >= 0 && a <= 1 && ip.x >= x1 && ip.x <= x2)
				return true;
			// zƂ̔
			if(ip1.x > ip2.x){
				std::swap(ip1, ip2);
			};
			dp = ip2 - ip1;
			a = (x1 - ip1.x) / (ip2.x - ip1.x);ip = ip1 + a * dp;
			if(a >= 0 && a <= 1 && ip.z >= z1 && ip.z <= z2)
				return true;
			a = (x2 - ip1.x) / (ip2.x - ip1.x);ip = ip1 + a * dp;
			if(a >= 0 && a <= 1 && ip.z >= z1 && ip.z <= z2)
				return true;
		};
		// z1xyʂƂ̌_
		s = ipz1.size();
//		if(s==3)
//			return true;
		if(s>1){
			D3DXVECTOR3 & ip1 = ipz1[0];
			D3DXVECTOR3 & ip2 = ipz1[1];
			FLOAT y1 = minp.y;
			FLOAT y2 = maxp.y;
			FLOAT x1 = minp.x;
			FLOAT x2 = maxp.x;
			// yƂ̔
			if(ip1.x > ip2.x){
				std::swap(ip1, ip2);
			};
			dp = ip2 - ip1;
			a = (x1 - ip1.x) / (ip2.x - ip1.x);ip = ip1 + a * dp;if(a >= 0 && a <= 1 && ip.y >= y1 && ip.y <= y2)
				return true;
			a = (x2 - ip1.x) / (ip2.x - ip1.x);ip = ip1 + a * dp;if(a >= 0 && a <= 1 && ip.y >= y1 && ip.y <= y2)
				return true;
			// xƂ̔
			if(ip1.y > ip2.y){
				std::swap(ip1, ip2);
			};
			dp = ip2 - ip1;
			a = (y1 - ip1.y) / (ip2.y - ip1.y);ip = ip1 + a * dp;if(a >= 0 && a <= 1 && ip.x >= x1 && ip.x <= x2)
				return true;
			a = (y2 - ip1.y) / (ip2.y - ip1.y);ip = ip1 + a * dp;if(a >= 0 && a <= 1 && ip.x >= x1 && ip.x <= x2)
				return true;
		};
		// z1xyʂƂ̌_
		s = ipz2.size();
//		if(s==3)
//			return true;
		if(s>1){
			D3DXVECTOR3 & ip1 = ipz2[0];
			D3DXVECTOR3 & ip2 = ipz2[1];
			FLOAT y1 = minp.y;
			FLOAT y2 = maxp.y;
			FLOAT x1 = minp.x;
			FLOAT x2 = maxp.x;
			// yƂ̔
			if(ip1.x > ip2.x){
				std::swap(ip1, ip2);
			};
			dp = ip2 - ip1;
			a = (x1 - ip1.x) / (ip2.x - ip1.x);ip = ip1 + a * dp;if(a >= 0 && a <= 1 && ip.y >= y1 && ip.y <= y2)
				return true;
			a = (x2 - ip1.x) / (ip2.x - ip1.x);ip = ip1 + a * dp;if(a >= 0 && a <= 1 && ip.y >= y1 && ip.y <= y2)
				return true;
			// xƂ̔
			if(ip1.y > ip2.y){
				std::swap(ip1, ip2);
			};
			dp = ip2 - ip1;
			a = (y1 - ip1.y) / (ip2.y - ip1.y);ip = ip1 + a * dp;if(a >= 0 && a <= 1 && ip.x >= x1 && ip.x <= x2)
				return true;
			a = (y2 - ip1.y) / (ip2.y - ip1.y);ip = ip1 + a * dp;if(a >= 0 && a <= 1 && ip.x >= x1 && ip.x <= x2)
				return true;
		};

		return false;
	};


	// Op`ƕʎlp`邩
	/*
	bool fIntersect_plane_triangle(const D3DXVECTOR3 & p1, const D3DXVECTOR3 & p2, const D3DXVECTOR3 & p3,
		const D3DXVECTOR3 & minp, const D3DXVECTOR3 & maxp){

		D3DXVECTOR3 va, vb, ip;
		FLOAT a, b, c, d;
		FLOAT ix, iy, iz;

		va = p2 - p1;
		vb = p3 - p1;
		// Op`镽ʂ̌vZ ax + by + cz + d = 0
		a = (p2.y - p1.y) * (p3.z - p1.z) - (p3.y - p1.y) * (p2.z - p1.z);
		b = (p2.z - p1.z) * (p3.x - p1.x) - (p3.z - p1.z) * (p2.x - p1.x);
		c = (p2.x - p1.x) * (p3.y - p1.y) - (p3.x - p1.x) * (p2.y - p1.y);
		d = -p1.x * a - p1.y * b - p1.z * c;
		// x = -(d + by1 + cz1) / a
		if(fabs(a) > 0.000001){
			ip.y = minp.y;ip.z = minp.z;ip.x = -(d + b * ip.y + c * ip.z) / a;
			if(fIntersect_point_triangle(ip - p1, va, vb))
				return true;
			ip.y = minp.y;ip.z = maxp.z;ip.x = -(d + b * ip.y + c * ip.z) / a;
			if(fIntersect_point_triangle(ip - p1, va, vb))
				return true;
			ip.y = maxp.y;ip.z = minp.z;ip.x = -(d + b * ip.y + c * ip.z) / a;
			if(fIntersect_point_triangle(ip - p1, va, vb))
				return true;
			ip.y = maxp.y;ip.z = maxp.z;ip.x = -(d + b * ip.y + c * ip.z) / a;
			if(fIntersect_point_triangle(ip - p1, va, vb))
				return true;
		};//fi
		// y = -(d + ax1 + cz1) / b
		if(fabs(b) > 0.000001){
			ip.x = minp.x;ip.z = minp.z;ip.y = -(d + a * ip.x + c * ip.z) / b;
			if(fIntersect_point_triangle(ip - p1, va, vb))
				return true;
			ip.x = minp.x;ip.z = maxp.z;ip.y = -(d + a * ip.x + c * ip.z) / b;
			if(fIntersect_point_triangle(ip - p1, va, vb))
				return true;
			ip.x = maxp.x;ip.z = minp.z;ip.y = -(d + a * ip.x + c * ip.z) / b;
			if(fIntersect_point_triangle(ip - p1, va, vb))
				return true;
			ip.x = maxp.x;ip.z = maxp.z;ip.y = -(d + a * ip.x + c * ip.z) / b;
			if(fIntersect_point_triangle(ip - p1, va, vb))
				return true;
		};//fi

		// z = -(d + ax1 + by1) / c
		if(fabs(c) > 0.000001){
			ip.x = minp.x;ip.y = minp.y;ip.z = -(d + a * ip.x + b * ip.y) / c;
			if(fIntersect_point_triangle(ip - p1, va, vb))
				return true;
			ip.x = minp.x;ip.y = maxp.y;ip.z = -(d + a * ip.x + b * ip.y) / c;
			if(fIntersect_point_triangle(ip - p1, va, vb))
				return true;
			ip.x = maxp.x;ip.y = minp.y;ip.z = -(d + a * ip.x + b * ip.y) / c;
			if(fIntersect_point_triangle(ip - p1, va, vb))
				return true;
			ip.x = maxp.x;ip.y = maxp.y;ip.z = -(d + a * ip.x + b * ip.y) / c;
			if(fIntersect_point_triangle(ip - p1, va, vb))
				return true;
		};//fi

		return false;
	};
	*/

	bool fIntersect_point_triangle(const D3DXVECTOR3 & p, const D3DXVECTOR3 & a, const D3DXVECTOR3 & b){

		FLOAT u, v, aa, ab, bb, ap, bp;

		aa = D3DXVec3Dot(&a, &a);
		ab = D3DXVec3Dot(&a, &b);
		bb = D3DXVec3Dot(&b, &b);
		ap = D3DXVec3Dot(&a, &p);
		bp = D3DXVec3Dot(&b, &p);

		u = (ap - bp / bb) / (aa - ab / bb);
		v = (bp - u * ab) / bb;
		if(u>= 0 && v >= 0 && (u+v) <= 1.0)
			return true;

		return false;
	};

	//*******************************************
	//     `֘A
	//*******************************************
	void draw(CDC *pDC)
	{
		int i;
		
		draw_own(pDC);
		for(i = 0; i < 8;i++){
			if(pChild[i]){
				pChild[i]->draw(pDC);
			};
		};
	};
	void draw_own(CDC *pDC, DWORD col = RGB(255,0,0))
	{
		CPen pen(PS_SOLID, 1, col), *oldpen;
		oldpen = pDC->SelectObject(&pen);
		int i;
		CPoint dp[5];
		dp[0] = dp[4] = CPoint(min_pt.x, min_pt.y);
		dp[1] = CPoint(max_pt.x,  min_pt.y);
		dp[2] = CPoint(max_pt.x,  max_pt.y);
		dp[3] = CPoint(min_pt.x,  max_pt.y);
		pDC->Polyline(dp, 5);
		//		
		pDC->SelectObject(oldpen);
		pen.DeleteObject();
	};
	//*******************************************

	bool Trace(
		const D3DXVECTOR3 &origin,
		FLOAT tx0, FLOAT ty0, FLOAT tz0,
		FLOAT tx1, FLOAT ty1, FLOAT tz1,
		unsigned int a,
		unsigned int b,
		HitRecord & record
		)
	{

		// Exit if the ray does not intersect the voxel.
		if(tx1 < 0.0 || ty1 < 0.0 || tz1 < 0.0)
			return false;   // continue octree traversal
		
		const FLOAT EPSILON = 0.0000001f;
		const FLOAT INF = 1e9;
		// If it is a leaf, visit it.
		if(fLeaf) {
			FLOAT t0 = max(tx0, max(ty0, tz0));
			FLOAT t1 = min(tx1, min(ty1, tz1));			
			//
			// {NZ̎Op`T
			//
			int i;
			FLOAT min_d = INF;
			bool fFound = false;
			HitRecord trec = record;

			Ray & ray = record.ray;
			Ray min_ray = ray;
			pTriangle triFound = NULL;
			
			if(record.pObject){
				record.pObject->hit(ray, 0, INF, trec);
				if(trec.t > 0 && 
					trec.p.x >= min_pt.x - EPSILON && trec.p.x <= max_pt.x + EPSILON&&
					trec.p.y >= min_pt.y - EPSILON && trec.p.y <= max_pt.y + EPSILON&&
					trec.p.z >= min_pt.z - EPSILON && trec.p.z <= max_pt.z + EPSILON){
					min_d = trec.t;
					fFound = true;
					record = trec;
					triFound = record.pObject;
					min_ray = ray;
				};
			};

			for(i = 0; i < objects.size();i++)
			{
				if(objects[i]->id != ray.id){
					// qbg
					if(objects[i]->hit(ray, 0, min_d, trec) 
						&& (record.shadow_d < 0 || (record.shadow_d > 0 && record.shadow_d > trec.t))){
						record.pObject = objects[i];
						objects[i]->id = ray.id;
						min_d = trec.t;
						min_ray = ray;
						// qbg_{NZɊ܂܂邩H
						if(
							record.shadow_d > 0 || (
							trec.p.x >= min_pt.x - EPSILON && trec.p.x <= max_pt.x + EPSILON&&
							trec.p.y >= min_pt.y - EPSILON && trec.p.y <= max_pt.y + EPSILON&&
							trec.p.z >= min_pt.z - EPSILON && trec.p.z <= max_pt.z + EPSILON)
							){
							fFound = true;
							record = trec;
							triFound = record.pObject;
						};
					};
				};
			};// i

			if(min_d > 0 && min_d < INF && fFound){
				ray = min_ray;
				record.pObject = triFound;
				return true;
			};

			return false;
		}

		//**************************************************************************
		// Compute the intersection between the ray and the three middle planes.
		// go[X from toxic
		//**************************************************************************
		
		const FLOAT &x0 = min_pt.x;
		const FLOAT &y0 = min_pt.y;
		const FLOAT &z0 = min_pt.z;
		const FLOAT &x1 = max_pt.x;
		const FLOAT &y1 = max_pt.y;
		const FLOAT &z1 = max_pt.z;
		
		FLOAT txm, tym, tzm;
		
		switch(b) {
		case 0:
			txm = 0.5 * (tx0 + tx1);
			tym = 0.5 * (ty0 + ty1);
			tzm = 0.5 * (tz0 + tz1);
			break;
		case 1:
			txm = 0.5 * (tx0 + tx1);
			tym = 0.5 * (ty0 + ty1);
			tzm = origin.z < 0.5 * (z0 + z1) ? +INF : -INF;
			break;
		case 2:
			txm = 0.5 * (tx0 + tx1);
			tym = origin.y < 0.5 * (y0 + y1) ? +INF : -INF;
			tzm = 0.5 * (tz0 + tz1);
			break;
		case 3:
			txm = 0.5 * (tx0 + tx1);
			tym = origin.y < 0.5 * (y0 + y1) ? +INF : -INF;
			tzm = origin.z < 0.5 * (z0 + z1) ? +INF : -INF;
			break;
		case 4:
			txm = origin.x < 0.5 * (x0 + x1) ? +INF : -INF;
			tym = 0.5 * (ty0 + ty1);
			tzm = 0.5 * (tz0 + tz1);
			break;
		case 5:
			txm = origin.x < 0.5 * (x0 + x1) ? +INF : -INF;
			tym = 0.5 * (ty0 + ty1);
			tzm = origin.z < 0.5 * (z0 + z1) ? +INF : -INF;
			break;
		case 6:
			txm = origin.x < 0.5 * (x0 + x1) ? +INF : -INF;
			tym = origin.y < 0.5 * (y0 + y1) ? +INF : -INF;
			tzm = 0.5 * (tz0 + tz1);
			break;
		case 7:
			txm = origin.x < 0.5 * (x0 + x1) ? +INF : -INF;
			tym = origin.y < 0.5 * (y0 + y1) ? +INF : -INF;
			tzm = origin.z < 0.5 * (z0 + z1) ? +INF : -INF;
			break;
		default:
			;
		}
		
		unsigned int current_octant = 0;
		
		if(tx0 > ty0) {
			if(tx0 > tz0) {
				// max(tx0, ty0, tz0) is tx0. Entry plane is YZ.
				if(tym < tx0) current_octant |= 2;
				if(tzm < tx0) current_octant |= 1;
			} else {
				// max(tx0, ty0, tz0) is tz0. Entry plane is XY.
				if(txm < tz0) current_octant |= 4;
				if(tym < tz0) current_octant |= 2;
			}
		} else {
			if(ty0 > tz0) {
				// max(tx0, ty0, tz0) is ty0. Entry plane is XZ.
				if(txm < ty0) current_octant |= 4;
				if(tzm < ty0) current_octant |= 1;
			} else {
				// max(tx0, ty0, tz0) is tz0. Entry plane is XY.
				if(txm < tz0) current_octant |= 4;
				if(tym < tz0) current_octant |= 2;
			}
		}
		
		// This special state indicates algorithm termination.
		const unsigned int END = 8;
		
		while(true) {
			switch(current_octant) {
			case 0:
				if(pChild[a]->Trace(origin, tx0, ty0, tz0, txm, tym, tzm, a, b, record))
					return true;
				current_octant = choose_next(txm, tym, tzm, 4, 2, 1);
				break;
			case 1:
				if(pChild[1 ^ a]->Trace(origin, tx0, ty0, tzm, txm, tym, tz1, a, b, record))
					return true;
				current_octant = choose_next(txm, tym, tz1, 5, 3, END);
				break;
			case 2:
				if(pChild[2 ^ a]->Trace(origin, tx0, tym, tz0, txm, ty1, tzm, a, b, record))
					return true;
				current_octant = choose_next(txm, ty1, tzm, 6, END, 3);
				break;
			case 3:
				if(pChild[3 ^ a]->Trace(origin, tx0, tym, tzm, txm, ty1, tz1, a, b, record))
					return true;
				current_octant = choose_next(txm, ty1, tz1, 7, END, END);
				break;
			case 4:
				if(pChild[4 ^ a]->Trace(origin, txm, ty0, tz0, tx1, tym, tzm, a, b, record))
					return true;
				current_octant = choose_next(tx1, tym, tzm, END, 6, 5);
				break;
			case 5:
				if(pChild[5 ^ a]->Trace(origin, txm, ty0, tzm, tx1, tym, tz1, a, b, record))
					return true;
				current_octant = choose_next(tx1, tym, tz1, END, 7, END);
				break;
			case 6:
				if(pChild[6 ^ a]->Trace(origin, txm, tym, tz0, tx1, ty1, tzm, a, b, record))
					return true;
				current_octant = choose_next(tx1, ty1, tzm, END, END, 7);
				break;
			case 7:
				if(pChild[7 ^ a]->Trace(origin, txm, tym, tzm, tx1, ty1, tz1, a, b, record))
					return true;
			case END:
				return false;
			}
		};
		};
};


//*********************
// INc[ǗNX
//*********************
class octree {
	
public:
	octree(){id = 1;}
	//************************************
	//@INc[̍\z
	//************************************
	void construct(D3DXVECTOR3 & min_pt, D3DXVECTOR3 & max_pt){
		
		root.oct_node::oct_node(min_pt, max_pt);
		
	};//
	void draw(CDC *pDC){

		root.draw(pDC);
	};


	//****************************************
	//   from toxic
	//****************************************
	bool Trace(D3DXVECTOR3 origin, D3DXVECTOR3 direction, HitRecord & record) {
		
		const D3DXVECTOR3 &box_min = root.min_pt;
		const D3DXVECTOR3 &box_max = root.max_pt;
		
		const FLOAT EPSILON = 1e-9;
		
		unsigned int a = 0;
		unsigned int b = 0;
		
		record.ray.id = id++;

		if(direction.x == 0.0) {
			direction.x = EPSILON;
			b |= 4;
		} else if(direction.x < 0.0) {
			origin.x = (box_min.x + box_max.x) - origin.x;
			direction.x = -direction.x;
			a |= 4;
		}
		
		if(direction.y == 0.0) {
			direction.y = EPSILON;
			b |= 2;
		} else if(direction.y < 0.0) {
			origin.y = (box_min.y + box_max.y) - origin.y;
			direction.y = -direction.y;
			a |= 2;
		}
		
		if(direction.z == 0.0) {
			direction.z = EPSILON;
			b |= 1;
		} else if(direction.z < 0.0) {
			origin.z = (box_min.z + box_max.z) - origin.z;
			direction.z = -direction.z;
			a |= 1;
		}
				
		FLOAT tx0 = (box_min.x - origin.x) / direction.x;
		FLOAT tx1 = (box_max.x - origin.x) / direction.x;
		FLOAT ty0 = (box_min.y - origin.y) / direction.y;
		FLOAT ty1 = (box_max.y - origin.y) / direction.y;
		FLOAT tz0 = (box_min.z - origin.z) / direction.z;
		FLOAT tz1 = (box_max.z - origin.z) / direction.z;
		
		if(max(tx0, max(ty0, tz0)) < min(tx1, min(ty1, tz1)))
			return root.Trace(origin, tx0, ty0, tz0, tx1, ty1, tz1, a, b, record);

		return false;
	}
	
public:
	oct_node root;
	int id;
};


#endif

