//
//   pXg[T[̃NX path_tracer.cpp
//      by g0307 2006
//

#include "stdafx.h"
#include "path_tracer.h"

Color PathTracer::trace(const Ray & ray, bool & fEmitt)
{
	Color color(0.0f, 0.0f, 0.0f);
	D3DXVECTOR3	upper(0.0f, -1.0f, 0.0f);

	// ڂ̔˂H
	depth++;

	if(depth > (max_depth + refract_depth) || refract_depth > 8){
		return color;
	};
	//********************
	HitRecord record;
	// ɏՓ˂
	if(hit(ray, record)){
		color = shade(record.p, ray.v, record.normal, record.bx, record.by, record.u, record.v, record.direction_sign, *record.pMaterial, record.t);
		fEmitt = false;
	} else {
		if(1 || ray.v.z > 0){
			color = ibl.get_color(ray.v);	
			fEmitt = true;
		};
	};
	return color;
}

Color PathTracer::shade(const D3DXVECTOR3 & x, const D3DXVECTOR3 & v, const D3DXVECTOR3 & n, 
						const D3DXVECTOR3 & bx, const D3DXVECTOR3 & by, 
						const FLOAT & U, const FLOAT & V, 
						const FLOAT & direction, const Material & mat, const FLOAT & t)
{
	Color color(0.0f, 0.0f, 0.0f);
	Ray ray, shadow_ray, preject_ray, preject_ray_u, preject_ray_d, specular_ray;
	FLOAT fresnel_scale, ep;
	HitRecord shadow_hit, project_hit, project_hit_d, project_hit_u;
	D3DXVECTOR3 light_x;
	Color L, D;
	bool fEmitt;

	int i, j;
	if(mat.type == DIFFUSE_MATERIAL){
		//*******************************************
		//           gǓvZ
		//*******************************************
		Color ref = mat.get_color(U, V);
		//************************************
		//         IBL̊^vZ
		//************************************
		Color ibl_color = get_ibl_color(x, n) / D3DX_PI;
		color.x = color.x + ibl_color.x * ref.x;
		color.y = color.y + ibl_color.y * ref.y;
		color.z = color.z + ibl_color.z * ref.z;
		// _ɐCgăg[X
		if(mat.diffuse_ray(x, n, bx, by, ray)){
			ray.ignor_light = false;
			bool fEmitt;
			Color diffuse = trace(ray, fEmitt);
			if(!fEmitt){
				// Ȃ炩̊^ꍇ
				color.x = (color.x + 2.0f * max(diffuse.x, 0) * ref.x) * 0.5;
				color.y = (color.y + 2.0f * max(diffuse.y, 0) * ref.y) * 0.5;
				color.z = (color.z + 2.0f * max(diffuse.z, 0) * ref.z) * 0.5;
			};// fi
		};
		
	} else if(mat.type == DIFFUSE_SPECULAR){
		//*******************************************
		//           gU+
		//*******************************************
		FLOAT Fr, P, pow_d, pow_r, pow_a;

		Color ref = mat.get_color(U, V);
		
		pow_d = ref.x + ref.y + ref.z;
		pow_r = mat.specular.x + mat.specular.y + mat.specular.z;
		pow_a = pow_d + pow_r;
		pow_d /= pow_a;
		pow_r /= pow_a;
		
		Fr = min(max(mat.fresnel_refrectance(mat.eta, -D3DXVec3Dot(&n, &v)), 0), 1.0);
		P = rng.random();
		
		if(P < pow_d){
			//************************************
			//         IBL̊^vZ
			//************************************
			Color ibl_color = get_ibl_color(x, n) / D3DX_PI;
			color.x = color.x + ibl_color.x * ref.x;
			color.y = color.y + ibl_color.y * ref.y;
			color.z = color.z + ibl_color.z * ref.z;
			// _ɐCgăg[X
			if(mat.diffuse_ray(x, n, bx, by, ray)){
				ray.ignor_light = true;
				Color diffuse = trace(ray, fEmitt);
				if(!fEmitt){
				color.x = (color.x + 2.0f * (1.0 - Fr) * max(diffuse.x, 0) * ref.x / pow_d) * 0.5;
				color.y = (color.y + 2.0f * (1.0 - Fr) * max(diffuse.y, 0) * ref.y / pow_d) * 0.5;
				color.z = (color.z + 2.0f * (1.0 - Fr) * max(diffuse.z, 0) * ref.z / pow_d) * 0.5;
				}
			};	
		} else {
			// ː
			specular_ray.v = -2 * D3DXVec3Dot(&n, &v) * n + v;
			specular_ray.x = x + specular_ray.v * 0.0001f;
			specular_ray.ignor_light = false;
			Color specular = trace(specular_ray, fEmitt);
			color.x = color.x + specular.x * mat.specular.x * Fr / (1 - pow_d);
			color.y = color.y + specular.y * mat.specular.y * Fr / (1 - pow_d);
			color.z = color.z + specular.z * mat.specular.z * Fr / (1 - pow_d);
		};
		
	} else if(mat.type == REFRACT_SPECULAR){
		//*******************************************
		//           +
		//*******************************************
		FLOAT Fr, P, pow_d, pow_r, pow_a;
		
		pow_d = mat.R->rgb.x + mat.R->rgb.y + mat.R->rgb.z;
		pow_r = mat.specular.x + mat.specular.y + mat.specular.z;
		pow_a = pow_d + pow_r;
		pow_d /= pow_a;
		pow_r /= pow_a;
		pow_d = 0.5;
		
		Fr = max(mat.fresnel_transmittance(1.5, -D3DXVec3Dot(&n, &v)), 0);
		P = rng.random();
		
		if(0 && P < pow_d){
			// ː
			specular_ray.v = -2 * D3DXVec3Dot(&n, &v) * n + v;
			specular_ray.x = x + specular_ray.v * 0.0001f;
			Color specular = trace(specular_ray, fEmitt);
			color.x = color.x + specular.x * mat.specular.x * Fr / (1 - pow_d);
			color.y = color.y + specular.y * mat.specular.y * Fr / (1 - pow_d);
			color.z = color.z + specular.z * mat.specular.z * Fr / (1 - pow_d);

		} else {
			if(mat.refract_ray(x, v, n, bx, by, direction, ray, fresnel_scale, 1.0/1.5)){
				refract_depth++;
				Color refract = trace(ray, fEmitt);
				color = refract * Fr;
			} else {
				// ː
				specular_ray.v = -2 * D3DXVec3Dot(&n, &v) * n + v;
				specular_ray.x = x + specular_ray.v * 0.0001f;
				specular_ray.ignor_light = false;
				Color specular = trace(specular_ray, fEmitt);
				color.x = color.x + specular.x * mat.specular.x;
				color.y = color.y + specular.y * mat.specular.y;
				color.z = color.z + specular.z * mat.specular.z;
			};
		};
	
	} else if(mat.type == SSS_MATERIAL){
		//*******************************************
		//           rrřvZ
		//*******************************************
		FLOAT s_i, s_ip, s_op, eta, fcos;
		D3DXVECTOR3 sig_a, sig_s, sig_t, sig_tr, albedo;
		FLOAT mean_sig_a, mean_sig_s, mean_sig_t, mean_sig_tr, mean_albedo;
		D3DXVECTOR3 x_s, x_i, w_i, w_o, w_ip, w_op, n_i;
		int j;
		
		FLOAT ep;
		Color ref, ref_s;
		ep = ibl.sampling_dir_color(shadow_ray.v, ref);
		ref_s = ref = ref / ep;
		light_x = x + shadow_ray.v * 10000000.0f;
		
		for(j = 0; j < 3; j++){
			if(mat.fTexture){
				albedo[j] = mat.sss_LUT[int(floor(mat.get_color(U, V)[j] * 255))];
				sig_tr[j] = 1.0f / (10.0f);
				sig_t[j] = sig_tr[j] / sqrt(3.0 * (1 - albedo[j]));
				sig_s[j] = albedo[j] * sig_t[j];
				sig_a[j] = sig_t[j] - sig_s[j];
			} else {
				sig_a[j] = mat.sigma_a[j];
				sig_s[j] = mat.sigma_s[j];
				sig_t[j] = sig_a[j] + sig_s[j];
				sig_tr[j] = sqrt(3.0f * sig_a[j] * sig_t[j]);
				albedo[j] = sig_s[j] / sig_t[j];
			};			
		};// j
		mean_albedo = (albedo.x + albedo.y + albedo.z) / 3.0f;
		mean_sig_tr = (sig_tr.x + sig_tr.y + sig_tr.z) / 3.0f;
		mean_sig_t = mean_sig_tr / sqrt(3.0 * (1 - mean_albedo));
		mean_sig_s = mean_albedo * mean_sig_t;
		mean_sig_a = mean_sig_t - mean_sig_s;
		
		//***************************************************
		//             gU
		//***************************************************
		D3DXVECTOR3 Rd;
		
		FLOAT d, scale_d = 0.2f / m_sss_scale;
		mat.sampling_diffuse_distance(x, bx, by, mean_sig_tr, mean_sig_t, mean_sig_s, mean_albedo, x_i, d, scale_d);
		
		//**************************************
		// x_i @-nɌĎˉe
		//**************************************
		int sign;
		preject_ray_u.x = x_i + 0.00001 * n;
		preject_ray_u.v = n;
		preject_ray_d.x = x_i + 0.00001 * n;
		preject_ray_d.v = -n;
		bool fp1 = hit(preject_ray_u, project_hit_u);
		bool fp2 = hit(preject_ray_d, project_hit_d);
		if(fp1 && (project_hit_u.t < project_hit_d.t || !fp2)){
			project_hit = project_hit_u;
			sign = -1;
		} else {
			project_hit = project_hit_d;
			sign = 1;
		};		
		
		if(project_hit.t >= 0 && project_hit.t < 10000.0){
			x_i = project_hit.p;			 // ˉeċ܂ʒux_i
			n_i = sign * project_hit.normal; //                 @n_i
			//
			Color dep;			
			//*******************************************
			//  Diffuse Term
			//*******************************************
			FLOAT U2, V2;
			U2 = project_hit.u;
			V2 = project_hit.v;
			
			shadow_ray.x = x_i + n_i * 0.0001f;
			// _ɐCgăg[X

			if(0 && mat.diffuse_ray(x_i, n_i, bx, by, ray)){
				bool fEmitt;
				Color diffuse = trace(ray, fEmitt);
				diffuse.x = max(diffuse.x, 0);
				diffuse.y = max(diffuse.y, 0);
				diffuse.z = max(diffuse.z, 0);
				if(hit_shadow(light_x, shadow_ray, shadow_hit)){
					ref = 2.0f * max(D3DXVec3Dot(&ray.v, &n_i), 0) * diffuse * 3.14159;
				}else if(!fEmitt){
					// Ȃ炩̊^ꍇ
					ref = (max(D3DXVec3Dot(&shadow_ray.v, &n_i), 0) * ref + 
						2.0f * max(D3DXVec3Dot(&ray.v, &n_i), 0) * diffuse * 3.14159) * 0.5;
				};// fi
			};

			ref = max(D3DXVec3Dot(&shadow_ray.v, &n_i), 0) * ref;

			for(j = 0; j < 3; j++){
				if(mat.fTexture){
					albedo[j] = mat.sss_LUT[int(floor(mat.get_color(U2, V2)[j] * 255))];
					sig_tr[j] = 1.0f / (10.0f);
					sig_t[j] = sig_tr[j] / sqrt(3.0 * (1 - albedo[j]));
					sig_s[j] = albedo[j] * sig_t[j];
					sig_a[j] = sig_t[j] - sig_s[j];
				}			
				Rd[j] = mat.calc_diffuse_approximation(
					sig_tr[j], sig_t[j], sig_s[j], albedo[j],
					x_i, d, dep[j]);
				if(albedo[j] > 0 && albedo[j] <= 1.0){
					FLOAT p = Rd[j] * ref[j] / dep[j];
					if(p > 0 && p < 1.0)
						color[j] = color[j] + albedo[j] * p;
				};//fi
			};// j	
		};// projection
		// SINGLE SCATTING
		FLOAT sss_scale;
		// stabɃ_ɐiʒux_svZ
		if(mat.sss_ray(x, v, n, bx, by, direction, mean_sig_a, mean_sig_s, ray, x_s, fresnel_scale, s_op, m_sss_scale) && s_op > 0.0001){
			//***************************************************************
			//  U_@x_s@eɌăVhEC΂B
			//   ̃VhECAĂstab\ʂɂԂ_x_iƂB
			//***************************************************************	
			Material * pMat;
			ray.x = x + v * 0.0001;
			FLOAT d1;
			if(hit(ray, shadow_hit) && shadow_hit.pMaterial->type == SSS_MATERIAL){

				d1 = shadow_hit.t;
				if(d1 < s_op){
					s_op = d1;
					x_s = shadow_hit.p - v * 0.0001f;
				};
				shadow_ray.x = x_s;
				// VhECŏɂԂʂ߂
				if(hit(shadow_ray, shadow_hit) && shadow_hit.pMaterial->type == SSS_MATERIAL){
					// x_iɂԂގSSSȂΌvZ𑱂
					s_i = shadow_hit.t;
					n_i = shadow_hit.normal;
					x_i = shadow_hit.p + shadow_ray.v * 0.0001f;
					w_i = w_ip = shadow_ray.v;
					w_o  = v;
					w_op = ray.v;
					eta = shadow_hit.pMaterial->eta;
					fcos = fabs(D3DXVec3Dot(&w_ip, &n_i));					
					s_ip = s_i * fcos / sqrt(1.0f - (1.0/eta)*(1.0/eta)*(1.0f - fcos * fcos ));
					// x_iVhEC΂AɒHt邩`FbN
					shadow_ray.x = x_i + shadow_ray.v * 0.001f;
					if(!hit_shadow(light_x, shadow_ray, shadow_hit)){
						//*******************************************
						//  Single Scatting Term
						//*******************************************
						for(j = 0; j < 3; j++){
							sss_scale = mat.sss_scale(w_i, w_o, w_ip, w_op, n_i, n, sig_a[j], sig_s[j], sig_t[j], s_ip, s_op, m_sss_scale);
							if(sss_scale < 0)sss_scale=0;
							color[j] = (color[j] + 4.0f * D3DX_PI * sss_scale * ref_s[j]) * 0.5;				
						};//j
					};//fi
				}///fi
				
			};//fi
		};//fi
		
		//**********************************
		// tl
		//**********************************
		if(0){
			FLOAT Fr = mat.fresnel_refrectance(0.3, fabs(D3DXVec3Dot(&n, &v)));
//			FLOAT Fr = mat.fresnel_refrectance(mat.eta, fabs(D3DXVec3Dot(&n, &v)));
			specular_ray.v = -2 * D3DXVec3Dot(&n, &v) * n + v;
			specular_ray.x = x + specular_ray.v * 0.0001f;
			Color specular = trace(specular_ray, fEmitt);
			color.x = color.x + specular.x * mat.specular.x * Fr;
			color.y = color.y + specular.y * mat.specular.y * Fr;
			color.z = color.z + specular.z * mat.specular.z * Fr;
		} 
	};
	
	return color;
}

void PathTracer::clear()
{
	triangles.clear();
	light_objects.clear();
}

void PathTracer::draw_triangles(CDC *pDC)
{

	int i = 0;
	
	for(i = 0; i < triangles.size(); i++)
		triangles[i]->draw(pDC);
	
	for(i = 0; i < light_objects.size(); i++)
		light_objects[i]->draw(pDC);
	
}

PathTracer::PathTracer()
{
	init();
}

void PathTracer::record_ray(const D3DXVECTOR3 & x, const Color & color)
{
	return;
}

void PathTracer::init()
{
	max_depth = 5;
	depth = 0;
	m_sss_scale = 1.0;
}

bool PathTracer::hit(const Ray &ray, HitRecord &record)
{

	record.t = 10000000;
	record.shadow_d = -1;
	record.pObject = NULL;
	record.ray = ray;

	if(root_octree.Trace(ray.x, ray.v, record)){

		return true;
	};//

	return false;

}

//
//     VhEC̔
//
bool PathTracer::hit_shadow(const D3DXVECTOR3 & x, const Ray &ray, HitRecord &record)
{

	D3DXVECTOR3 dp = x - ray.x;
	FLOAT shadow_d;

	shadow_d = sqrtf(D3DXVec3Dot(&dp, &dp)) - 0.001f;// ܂ł̋
	record.shadow_d = shadow_d;
	record.pObject = NULL;
	record.ray = ray;

	if(root_octree.Trace(ray.x, ray.v, record)){
		return true;
	};//

	record.t = shadow_d;
	return false;
}

void PathTracer::build_octree()
{
	int i;
	root_octree.root.clear();
	root_octree.construct(D3DXVECTOR3(-100.0f,-100.0f, -40.0f), D3DXVECTOR3(100.0f, 100.0f, 220.0f));
	for(i = 0; i < triangles.size();i++)
		root_octree.root.objects.push_back(triangles[i]);
	root_octree.root.divide();

}

//******************************************************************
//  xTvOăVhEC쐬
//******************************************************************
bool PathTracer::sampling_light(const D3DXVECTOR3 &x, const D3DXVECTOR3 &n, D3DXVECTOR3 & light_x, Ray &shadow_ray, Material ** pMat, FLOAT & ep)
{
	int i, index;

	FLOAT eta1, eta2, eta_u, eta_v;


	eta1 = rng.random();
	eta2 = rng.random();
	//VhECɂ钼ڌ̌vZ
	for(i = 0; i < light_dense.densities.size(); i++){
		light_density_t & ref = light_dense.densities[i];

		if(ref.pb <= eta1 && eta1 < ref.pe){
			index = ref.index;
			ep = (ref.pe - ref.pb);
			eta_u = (eta1 - ref.pb) / ep;
			eta_v = (1.0 - eta_u) * eta2;
			light_x = light_objects[index]->sampling_point(eta_u, eta_v);
			shadow_ray.from_2points(x, light_x);
			shadow_ray.x = x + shadow_ray.v * 0.001f;
			*pMat = light_objects[index]->pMaterial;
			ep = ep / -D3DXVec3Dot(&light_objects[index]->n, &shadow_ray.v);
			return true;
		};// fi
	};// i

	ep = 1.0;
	return false;
}
//******************************************************************
//  x
//******************************************************************
void PathTracer::build_light_density()
{
	int i;
	D3DXVECTOR3 light_x;
	FLOAT e, ec, p, pc;
	light_density_t tmp_e;

	light_dense.clear();
	//VhECɂ钼ڌ̌vZ
	ec = 0.0f;//ݐϊ^̌vZ
	for(i = 0; i < light_objects.size(); i++){
		Material * pMat = light_objects[i]->pMaterial;
		e = light_objects[i]->pMaterial->emittance;
		ec = ec + e;
	};//
	//ݐϊ^ŊĊmɂ
	pc = 0.0f;
	for(i = 0; i < light_objects.size(); i++){
		Material * pMat = light_objects[i]->pMaterial;
		p = light_objects[i]->pMaterial->emittance / ec;	
		tmp_e.pb = pc;
		tmp_e.pe = pc + p;
		tmp_e.index = i;
		pc = pc + p;
		light_dense.densities.push_back(tmp_e);
	};
};

void PathTracer::set_ibl(LPSTR filename)
{
//	ibl.construct_from_bmp(filename);
	ibl.construct_from_pfm(filename);
}

void PathTracer::set_ibl_raw(LPSTR filename, int _w, int _h)
{
	ibl.construct_from_bmp_raw(filename, _w, _h);
}

void PathTracer::set_EIHDRI(LPSTR filename)
{
	ibl.construct_from_txt(filename);
}

//********************************************************
//            IBL̊^vZ
//********************************************************
Color PathTracer::get_ibl_color(const D3DXVECTOR3 &x, const D3DXVECTOR3 &n)
{
	Ray shadow_ray;
	HitRecord shadow_hit;
	Color color(0.0f, 0.0f, 0.0f), ibl_color;
	FLOAT  p;

	int i, ibl_num;
	ibl_num = ibl.dir_colors.size();
	shadow_ray.ignor_light = true;
	p = ibl.sampling_dir_color(shadow_ray.v, ibl_color);
	shadow_ray.x = x + shadow_ray.v * 0.001f;
	// hak摜ɃVhEC΂ĂԂȂΊ^𑫂
	if(!hit(shadow_ray, shadow_hit) &&  D3DXVec3Dot(&n, &shadow_ray.v) > 0){
		color = color + ibl_color * D3DXVec3Dot(&n, &shadow_ray.v) / p;
	};
	
	return color;
}
