//
//   pXg[T[̃NX path_tracer.h
//      by g0307 2006
//


#ifndef _S_PATH_TRACER_
#define _S_PATH_TRACER_	1

#include "octree.h"	// ClassView ɂĒǉ܂B
#include "s_triangle.h"
#include "s_material.h"
#include "rng.h"
#include "s_color.h"	// ClassView ɂĒǉ܂B
#include "camera.h"

//**************************************************
//  C[Wx[XhCeBÕNX
//**************************************************
class IBL {

	struct dir_color_t {
		D3DXVECTOR3 dir;
		D3DXVECTOR3 color;
		FLOAT p;
	};

public:

	void construct_from_txt(LPSTR filename){

		int i;
		dir_colors.clear();
		std::ifstream str(filename);
		dir_color_t tmp;
		FLOAT dummy;

		str >> num_sample >> num_layer;

		for(i = 0; i < num_sample; i++){
			str >> tmp.dir.x >> tmp.dir.y >> tmp.dir.z 
				>> dummy >> dummy >> dummy 
				>> tmp.color.x >> tmp.color.y >> tmp.color.z;
			if(1 || tmp.dir.z < 0){
				tmp.dir.y = -tmp.dir.y;
				tmp.dir.z = -tmp.dir.z;
//				tmp.color = D3DXVECTOR3(0.02,0.02,0.02);
				dir_colors.push_back(tmp);
			}
		};//i
		num_sample = dir_colors.size();
		str.close();
		//************************************
		// Cg̃p[nbV̐
		//************************************
		light_hash.clear();
		FLOAT rp, delta_p, p;
		max_size = 10000;
		int index;
		light_hash.resize(max_size);
		rp = 0;
		for(i = 0; i < num_sample; i++){
			rp = rp + (dir_colors[i].color.x + dir_colors[i].color.y + dir_colors[i].color.z);
		};//i
		for(i = 0; i < num_sample; i++){
			dir_colors[i].p = (dir_colors[i].color.x + dir_colors[i].color.y + dir_colors[i].color.z) / rp;
		};//i
		delta_p =  1.0 / (FLOAT)max_size;
		index = rp = 0;
		p = dir_colors[0].p;
		int ddd[10000];
		for(i = 0; i < max_size; i++){
			light_hash[i] = index;
			ddd[i] = index;
			rp = rp + delta_p;
			if(rp > p){
				rp = rp - p;
				index++;
				p = dir_colors[index].p;
				if(index >= num_sample)
					index = num_sample - 1;
			};
		};
	};

	FLOAT sampling_dir_color(D3DXVECTOR3 & dir, D3DXVECTOR3 & color){

		int index = light_hash[floor(rng.random() * max_size)];

		dir = dir_colors[index].dir;
		color = dir_colors[index].color;

		return dir_colors[index].p * num_sample;
	};


	void construct_from_bmp(LPSTR filename){
		dib.read(NULL, filename);
		dib.decompose3(R, G, B);
		w = dib.width;
		h = dib.height;
		fEIHDRI = false;
	};
	void construct_from_bmp_raw(LPSTR filename, int _w, int _h){
		dib.resize(_w, _h);
		dib.decompose3(R, G, B);
		w = _w;
		h = _h;
		int x, y;
		FILE * fp = fopen(filename, "rb");
		FLOAT rgb[3];
		for(y = 0; y < h; y++){
			for(x = 0; x < w; x++){
				fread((FLOAT*)rgb, sizeof(FLOAT), 3, fp);
				*R.at(x, h - 1 - y) = rgb[0];
				*G.at(x, h - 1 - y) = rgb[1];
				*B.at(x, h - 1 - y) = rgb[2];
			};
		};
		fclose(fp);
		fEIHDRI = false;
	};
	void construct_from_pfm(LPSTR filename){
		int x, y;
		char buf[256];
		FILE * fp = fopen(filename, "rb");
		fscanf(fp,"%s\n", buf);
		fscanf(fp,"%d\n", &w);
		fscanf(fp,"%d\n", &h);
		fscanf(fp,"%s\n", buf);
		dib.resize(w, h);
		dib.decompose3(R, G, B);

		FLOAT rgb[3];
		for(y = 0; y < h; y++){
			for(x = 0; x < w; x++){
				fread((FLOAT*)rgb, sizeof(FLOAT), 3, fp);
				*R.at(x, h - 1 - y) = rgb[0];
				*G.at(x, h - 1 - y) = rgb[1];
				*B.at(x, h - 1 - y) = rgb[2];
			};
		};
		fclose(fp);
		fEIHDRI = false;
	};
	// xNgYF擾
	Color get_color(const D3DXVECTOR3 & p){

        FLOAT r, u, v, U, V;
		Color ret;

        r = acos(p.z) / (3.14159 * sqrtf(p.x * p.x + p.y * p.y));
        u = p.x * r;
        v = p.y * r;

        u = 0.5 * u + 0.5;
        v = 0.5 * v + 0.5;
		U = u * w;U = max(U, 0); U = min(U, w - 1);
		V = v * h;V = max(V, 0); V = min(V, h - 1);

		ret.x = R.cubic_at(U, V) / 255.0;
		ret.y = G.cubic_at(U, V) / 255.0;
		ret.z = B.cubic_at(U, V) / 255.0;

		return ret;
	};

	CDIB dib;
	gray_t R, G, B, L;
	RNG rng;
	int w, h;
	int max_size;
	bool fEIHDRI;
	std::vector<dir_color_t>    dir_colors;
	std::vector<unsigned short> light_hash;
	int num_sample, num_layer;


};//

// x̃f[^
struct light_density_t {
	FLOAT pb, pe;
	int index;
};
struct light_dense_t {
	std::vector<light_density_t> densities;
	FLOAT ec;
	void clear(){
		densities.clear();
	};
};


class PathTracer {
#define INFINTY_DIST	1e10

public:
	Color get_ibl_color(const D3DXVECTOR3 & x, const D3DXVECTOR3 & n);
	void set_EIHDRI(LPSTR filename);
	void set_ibl_raw(LPSTR filename, int _w, int _h);
	void set_ibl(LPSTR filename);
	RNG rng;
	void build_light_density();
	bool sampling_light(const D3DXVECTOR3 &x, const D3DXVECTOR3 &n, D3DXVECTOR3 & light_x, Ray &shadow_ray, Material ** pMat, FLOAT & ep);
	void build_octree();
	octree root_octree;
	bool hit(const Ray & ray, HitRecord & record);
	bool hit_shadow(const D3DXVECTOR3 & x, const Ray & ray, HitRecord & record);
	void init();
	void record_ray(const D3DXVECTOR3 & x, const Color & color);
	PathTracer();
	void draw_triangles(CDC *pDC);
	void clear();
	Color trace(const Ray & ray,  bool & fEmitt);
	Color shade(const D3DXVECTOR3 & x, const D3DXVECTOR3 & v, const D3DXVECTOR3 & n, 
		const D3DXVECTOR3 & bx, const D3DXVECTOR3 & by,
		const FLOAT & U, const FLOAT & V, 
		const FLOAT & direction, const Material & mat, const FLOAT & t);

	ptriangles_t	triangles;
	ptriangles_t	light_objects;
	materials_t	    materials;
	light_dense_t	light_dense;
	int depth, refract_depth, max_depth;
	IBL ibl;
	camera cam;
	FLOAT	m_sss_scale;

};

#endif

