#include "stdafx.h"
#include "s_material.h"


//**************************************************************************
//      d_ITvOgă_̕C𐶐
//**************************************************************************
bool Material::diffuse_ray(const D3DXVECTOR3 &x, const D3DXVECTOR3 &n, const D3DXVECTOR3 &bx, const D3DXVECTOR3 & by, Ray &ray) const
{

	ray.x = x + n * 0.0001f; // ƕ

	// d_ITvO
	FLOAT theta = acosf(sqrtf(rng.random()));
	FLOAT phi   = 2.0f*D3DX_PI * rng.random();
	// theta  phi 甽˃xNg쐬
	ray.v = sinf(theta) * cosf(phi) * bx + sinf(theta) * sinf(phi) * by + cosf(theta) * n;
	
	return true;
}
//**************************************************************************
//      ܓ˂郌C𐶐
//**************************************************************************
bool Material::refract_ray(const D3DXVECTOR3 & x, const D3DXVECTOR3 & v, const D3DXVECTOR3 &n, const D3DXVECTOR3 &bx, const D3DXVECTOR3 &by, const FLOAT & direction, Ray &ray, FLOAT & fresnel_scale, FLOAT _eta) const
{
	// ɓĂ邩oĂ邩͖@Ɠ˃xNg̓ς̕Ŕf
	FLOAT VN = -direction * D3DXVec3Dot(&v, &n), D;
	FLOAT sign;
	FLOAT _R0;

	// Ăꍇ
	if(VN < 0){
		VN = -VN;
		sign = 1.0;
		D = 1 - (1 - VN * VN) / (_eta * _eta);
		if(D > 0){
			// ܕ̌vZ
			ray.v =  (1/_eta) * v + (VN / _eta - sqrtf(D)) * n;
//			ray.x = x + ray.v * 0.00001f; //ƕ
			ray.x = x - n * 0.00001f; //ƕ
			D3DXVec3Normalize(&ray.v, &ray.v);
			return true;
		};
		_R0 = (_eta - 1.0f) / (_eta + 1.0f);

	} else {
		sign = -1.0;
		D = 1 - (1 - VN * VN) * (_eta * _eta);
		if(D > 0){
			// ܕ̌vZ
			ray.v =  _eta * v + (VN * _eta - sqrtf(D)) * n;
//			ray.x = x + ray.v * 0.00001f; //ƕ
			ray.x = x - n * 0.00001f; //ƕ
			D3DXVec3Normalize(&ray.v, &ray.v);
			return true;
		};
		_R0 = (1.0/_eta - 1.0f) / (1.0/_eta + 1.0f);
	};//fi

	_R0 *= _R0;
	FLOAT temp3 = 1.0f - VN;
	fresnel_scale = (1.0 - (_R0 + (1.0f - _R0) * temp3 * temp3 * temp3 * temp3 * temp3));
	return false;
}

//**************************************************************************
//      SSS̃C𐶐
//**************************************************************************
bool Material::sss_ray(const D3DXVECTOR3 & x, const D3DXVECTOR3 & v,
					   const D3DXVECTOR3 &n, const D3DXVECTOR3 &bx, const D3DXVECTOR3 &by,
					   const FLOAT & direction, const FLOAT & sigma_a, const FLOAT & sigma_s, 
					   Ray &ray, D3DXVECTOR3 & x_s, FLOAT & fresnel_scale, FLOAT & s_op, FLOAT scale) const
{
	// ɓĂ郌Ĉ
	FLOAT VN = D3DXVec3Dot(&v, &n), D;
	FLOAT _eta = 1.3;// / 1.5;
	// Ăꍇ
	if(VN < 0){
		VN = -VN;
		D = 1 - (1 - VN * VN) / (_eta * _eta);
		if(D > 0){
			// ܕ̌vZ
			ray.v =  (1/_eta) * v + (VN / _eta - sqrtf(D)) * n;
			ray.x = x + ray.v * 0.00001f; //ƕ
			D3DXVec3Normalize(&ray.v, &ray.v);
			FLOAT sigma_t = sigma_a + sigma_s;		
			s_op = -log(rng.random()) / (0.5 * scale * sigma_t);
			x_s = ray.x + s_op * ray.v;
			return true;
		}
	}
	return false;
	
}

//******************************************************
//  Single Scatting by Jensen
//******************************************************
FLOAT Material::sss_scale(
						  const D3DXVECTOR3 &w_i, const D3DXVECTOR3 &w_o, const D3DXVECTOR3 &w_ip, 
						  const D3DXVECTOR3 &w_op, const D3DXVECTOR3 &n_i, const D3DXVECTOR3 &n_o,  
						  FLOAT sig_a, FLOAT sig_s, FLOAT sig_t, FLOAT s_ip, FLOAT s_op, FLOAT scale) const
{

	FLOAT G, sig_tc, p, ei, eo, Fi, Fo, Rd, g = 0.8, ep;

	G = fabs((D3DXVec3Dot(&n_i, &w_o) / (D3DXVec3Dot(&n_i, &w_i))));
	sig_tc = sig_t + G * sig_t;
	ei = exp(-0.5 * scale * s_ip * sig_t);
	eo = exp(-0.5 * scale * s_op * sig_t);
	ep = s_op * exp(-0.5 * scale * s_op * sig_t);
	p = phase_function(g, D3DXVec3Dot(&w_ip, &w_op) );
	Fi = fresnel_transmittance(eta, -D3DXVec3Dot(&w_i, &n_i));
	Fo = fresnel_transmittance(eta, -D3DXVec3Dot(&w_o, &n_o));

	return min(1.0, Fi * Fo * ((sig_s / (1-g)) * p * ei * eo / (sig_tc)));

}

//******************************************************
//  Henyey Greenstein ̈ʑ֐
//******************************************************
FLOAT Material::phase_function(FLOAT g, FLOAT c) const
{

	return (1 - g * g) / (4.0f * D3DX_PI * powf(1.0f + g * g - 2 * g * c, 1.5f) );
} 


Color Material::emitt_color(const D3DXVECTOR3 & x0, const D3DXVECTOR3 & p, const D3DXVECTOR3 & n, const D3DXVECTOR3 & emit) const{
	Color color;

	color.x = emit.x;
	color.y = emit.y;
	color.z = emit.z;

	return color;
}
//******************************************************
// tl˗
//******************************************************
FLOAT Material::fresnel_refrectance(FLOAT _eta, FLOAT cosine) const
{
	FLOAT F0 = (1.0f - _eta) / (1.0f + _eta);
	F0 *= F0;
	cosine = 1.0f - cosine;

	// Schlick ߎ
	return F0 + (1.0f - F0) * cosine * cosine * cosine * cosine * cosine;
}
//******************************************************
// tlߗ
//******************************************************
FLOAT Material::fresnel_transmittance(FLOAT _eta, FLOAT cosine) const
{
	FLOAT F0 = (1.0f - _eta) / (1.0f + _eta);
	F0 *= F0;
	cosine = 1.0f - cosine;

	// Schlick ߎ
	return 1.0f - (F0 + (1.0f - F0) * cosine * cosine * cosine * cosine * cosine);
}

//******************************************************
// rrr̊gUdipoleߎ by Jensen
//******************************************************
FLOAT Material::diffuse_approximation(
									  const D3DXVECTOR3 & x, const D3DXVECTOR3 & light_x, 
									  const D3DXVECTOR3 & w_i, const D3DXVECTOR3 & w_o, 
									  const D3DXVECTOR3 & n_i, const D3DXVECTOR3 & n_o, 
									  const D3DXVECTOR3 & bx, const D3DXVECTOR3 & by,
									  FLOAT sig_a, FLOAT sig_s, FLOAT sig_t, FLOAT g,
									  FLOAT sig_tr, FLOAT sig_tp, FLOAT sig_sp, FLOAT alphap,
									  D3DXVECTOR3 & x_i) const
{

	FLOAT A, D, Fdr, Rd;
	FLOAT d, dr, dv, zr, zv;
	FLOAT Cr, Cv, shadow_d;
	FLOAT scale = 1.0f;
	D3DXVECTOR3 p_i;

	//W
	// ϊgUtl˗
	Fdr = average_fresnel_refrectance(eta);
	A = (1.0f + Fdr) / (1.0f - Fdr);
	// xi܂ł̋_ɔ
	d = -logf(rng.random()) / sig_tr;
	FLOAT ip = sig_tr * expf(-sig_tr * d);

	// dipole܂ł̋ zr: zv:
	zr = 1.0f / sig_tp;
	zv = (1.0f / sig_tp + 4 * A / 3.0f);
	FLOAT theta = rng.random() * 2.0f * D3DX_PI;
	x_i = x + 
		0.000001f * d * cos(theta) * bx + 
		0.000001f * d * sin(theta) * by;
	// xidipole܂ł̋
	dr = sqrtf(d*d+zr*zr);
	dv = sqrtf(d*d+zv*zv);
	// gU˗̌vZ
	Cr = zr * (sig_tr + 1.0f / dr);
	Cv = zv * (sig_tr + 1.0f / dv);
//	Rd = alphap * ( Cr * expf(-sig_tr*dr) / (dr*dr) + Cv * expf(-sig_tr*dv) / (dv*dv));
//  diffuse approxemation by BRDF(Jensen. 2001)
	FLOAT SQ = -sqrtf(3.0f*(1.0f - alphap));
//	FLOAT Rdd = (alphap / 2.0f) * (1.0f + expf(4.0f * A * SQ / 3.0f)) * expf(SQ);
	FLOAT Rdd = (1.0 / 2.0f) * (1.0f + expf(4.0f * A * SQ / 3.0f)) * expf(SQ);
//	dr *= 0.01;
//	dv *= 0.01;
	Rd = min(1.0, ( Cr * expf(-sig_tr *dr) / (dr*dr) + Cv * expf(-sig_tr * dv) / (dv*dv)));
//	Rd = min(1.0, ( Cr * expf(-sig_tr*dr) / (dr*dr) + Cv * expf(-sig_tr*dv) / (dv*dv)));
//		return Rd;
	Rd = Rd / (D3DX_PI * ip);

	return Rdd / D3DX_PI;
	return Rd;
//	return min(Rd / (D3DX_PI * ip), Rdd / D3DX_PI);

}

FLOAT Material::calc_diffuse_approximation(
									  FLOAT sig_tr, FLOAT sig_tp, FLOAT sig_sp, FLOAT alphap,
									  D3DXVECTOR3 & x_i, FLOAT & d, FLOAT & dep) const
{

	FLOAT A, D, Fdr, Rd;
	FLOAT dr, dv, zr, zv;
	FLOAT Cr, Cv, shadow_d;

	//W
	// ϊgUtl˗
	Fdr = average_fresnel_refrectance(eta);
	A = (1.0f + Fdr) / (1.0f - Fdr);
	dep = sig_tr * expf(-sig_tr * d);
	// dipole܂ł̋ zr: zv:
	zr = 1.0f / sig_tp;
	zv = (1.0f / sig_tp + 4 * A / 3.0f);
	FLOAT theta = rng.random() * 2.0f * D3DX_PI;
	// xidipole܂ł̋
	dr = sqrtf(d*d+zr*zr);
	dv = sqrtf(d*d+zv*zv);
	// gU˗̌vZ
	Cr = zr * (sig_tr + 1.0f / dr);
	Cv = zv * (sig_tr + 1.0f / dv);
//  diffuse approxemation by BRDF(Jensen. 2001)
	FLOAT SQ = -sqrtf(3.0f*(1.0f - alphap));
	FLOAT Rdd = (1.0 / 2.0f) * (1.0f + expf(4.0f * A * SQ / 3.0f)) * expf(SQ);
	Rd = min(1.0, ( Cr * expf(-sig_tr *dr) / (dr*dr) + Cv * expf(-sig_tr * dv) / (dv*dv)));
	Rd = Rd / (D3DX_PI);

//	return Rdd / D3DX_PI;
	return Rd;
}


void Material::sampling_diffuse_distance(
									  const D3DXVECTOR3 & x, 
									  const D3DXVECTOR3 & bx, const D3DXVECTOR3 & by,
									  FLOAT sig_tr, FLOAT sig_tp, FLOAT sig_sp, FLOAT alphap,
									  D3DXVECTOR3 & x_i, FLOAT & d, FLOAT & scale_d) const
{

	FLOAT A, Fdr;
	D3DXVECTOR3 p_i;

	// ϊgUtl˗
	Fdr = average_fresnel_refrectance(eta);
	A = (1.0f + Fdr) / (1.0f - Fdr);
	// xi܂ł̋_ɔ
	d = -logf(rng.random()) / sig_tr;
	FLOAT theta = rng.random() * 2.0f * D3DX_PI;
	x_i = x + 
		scale_d * d * cos(theta) * bx + 
		scale_d * d * sin(theta) * by;
}

//******************************************************
// σtlgU˗ by Egan
//******************************************************
FLOAT Material::average_fresnel_refrectance(FLOAT _eta) const
{
	if(_eta > 1.0)
	return -1.4399f / (_eta*_eta) + 0.7099f /_eta + 0.6681f + 0.0636f * _eta;

	return -0.4399f / (_eta*_eta) + 0.7099f /_eta - 0.3319f + 0.0636f * _eta;

}

// @obt@̊m
void Material::init_normalmap(int w, int h)
{

}

Material::Material()
{
	fNormalMap = false;
	fTexture = false;
	eta = 1.0;
}

Color Material::get_color(FLOAT u, FLOAT v) const
{
	return R->value(u, v);
}

void Material::build_sss_LUT()
{
	FLOAT A, Fdr;
	
	Fdr = -1.4399f / (eta*eta) + 0.7099f /eta + 0.6681f + 0.0636f * eta;
	A = (1 + Fdr) / (1- Fdr);
	
	int i;
	for(i = 0; i < 255;i++){
		sss_LUT[i] = find_root_Rd(A, (FLOAT)i / 255.0, 0.000001);
//		sss_LUT[i] = find_root_Rd(A, (FLOAT)i / 255.0, 0.00001);
	};

}

//
//  Rd()-Rd = 0𖞂̒Tij[g@j
//
FLOAT Material::find_root_Rd(FLOAT A, FLOAT rd, FLOAT epsiron)
{

	int k = 0;
	FLOAT a, b, aRd, bRd, alpha;
	bool fFind = false;
	a = 0;aRd = 0;
	b = 1.0;bRd = 1.0;
	while(k++<100 && !fFind){
		fFind = find_root_Rd_divide(a, b, aRd, bRd, rd, A, epsiron);
	};
	alpha = (a + b) * 0.5;

	return alpha;

}

//
// 񕪊@ɂ@
//
bool Material::find_root_Rd_divide(FLOAT & a, FLOAT &b, FLOAT & aRd, FLOAT &bRd, FLOAT & rd, FLOAT A, FLOAT epsiron)
{
	FLOAT c = (a + b) * 0.5;
	FLOAT cRd;

	cRd = c * expf(-sqrtf(3-3*c)) * (1 + expf(-4.0 * A * sqrtf( (1-c)/3.0f))) * 0.5;

	if(aRd < rd && rd < cRd - epsiron){
		bRd = cRd;
		b = c;
		return false;
	}
	if(cRd < rd + epsiron && rd <= bRd){
		aRd = cRd;
		a = c;
		return false;
	}

	return true;
}
