//*************************************************************
//  s_material.h  by g0307 2006
//   ގ̃NX
//*************************************************************

#ifndef _S_MATERIL_
#define _S_MATERIL_	1

#include "s_color.h"	// ClassView ɂĒǉ܂B
#include "RNG.h"
#include "s_texture.h"
#include "s_ray.h"

#define DIFFUSE_MATERIAL 0
#define REFRACT_MATERIAL 1
#define LIGHT_MATERIAL   2
#define DIFFUSE_SPECULAR 3
#define REFRACT_SPECULAR 4
#define SSS_MATERIAL	 5
#define PIXEL_NODIFINED	  -1000

class Material {

public:

	FLOAT calc_diffuse_approximation(
									  FLOAT sig_tr, FLOAT sig_tp, FLOAT sig_sp, FLOAT alphap,
									  D3DXVECTOR3 & x_i, FLOAT & d, FLOAT & dep) const;

	void sampling_diffuse_distance(	  const D3DXVECTOR3 & x, 
									  const D3DXVECTOR3 & bx, const D3DXVECTOR3 & by,
									  FLOAT sig_tr, FLOAT sig_tp, FLOAT sig_sp, FLOAT alphap,
									  D3DXVECTOR3 & x_i, FLOAT & d, FLOAT & scale_d) const;
	void build_sss_LUT();
	FLOAT find_root_Rd(FLOAT A, FLOAT rd, FLOAT epsiron);
	bool find_root_Rd_divide(FLOAT & a, FLOAT &b, FLOAT & aRd, FLOAT &bRd, FLOAT & rd, FLOAT A, FLOAT epsiron);

	Color get_color(FLOAT u, FLOAT v) const;
	Material();
	void init_normalmap(int w, int h);
	bool fNormalMap, fTexture;
	FLOAT sss_LUT[256];

	void set_specular(D3DXVECTOR3 & spec){
		specular = spec;
	};
	FLOAT average_fresnel_refrectance(FLOAT _eta) const;
	FLOAT diffuse_approximation(
  	    const D3DXVECTOR3 & x, const D3DXVECTOR3 & light_x, 
		const D3DXVECTOR3 & w_i, const D3DXVECTOR3 & w_o, 
		const D3DXVECTOR3 & n_i, const D3DXVECTOR3 & n_o, 
		const D3DXVECTOR3 & bx, const D3DXVECTOR3 & by,
		FLOAT sig_a, FLOAT sig_s, FLOAT sig_t, FLOAT g,
		FLOAT sig_tr, FLOAT sig_tp, FLOAT sig_sp, FLOAT alphap,
		D3DXVECTOR3 & x_i) const;
	FLOAT fresnel_refrectance(FLOAT _eta, FLOAT cosine) const;
	FLOAT fresnel_transmittance(FLOAT _eta, FLOAT cosine) const;


	Color emitt_color(const D3DXVECTOR3 & x0, const D3DXVECTOR3 & p, const D3DXVECTOR3 & n, const D3DXVECTOR3 & emit) const;

	FLOAT phase_function(FLOAT g, FLOAT c) const;
	FLOAT sss_scale(const D3DXVECTOR3 & w_i, const D3DXVECTOR3 & w_o, 
		const D3DXVECTOR3 &w_ip, const D3DXVECTOR3 &w_op, 
		const D3DXVECTOR3 &n_i, const D3DXVECTOR3 &n_o, 
		FLOAT sig_a, FLOAT sig_s, FLOAT sig_t, FLOAT s_ip, FLOAT s_op, FLOAT scale) const;
	void gen_diffuse_material(Texture * _R){
		type = DIFFUSE_MATERIAL;
		R = _R;
	};
	void gen_light_material(Texture * _R, FLOAT _emittance){
		type = LIGHT_MATERIAL;
		emittance = _emittance;
		R = _R;
	};
	void gen_refract_material(FLOAT _eta, Texture * _R){
		type = REFRACT_MATERIAL;
		eta = _eta;
		R0 = (eta - 1.0f) / (eta + 1.0f);
		R0 *= R0;
		R = _R;
	};
	void gen_sss_material(FLOAT _eta, Texture * _R, const Color & _sigma_a, const Color & _sigma_s){
		type = SSS_MATERIAL;
		eta = _eta;
		R0 = (eta - 1.0f) / (eta + 1.0f);
		R0 *= R0;
		if(_R)
			R = _R;
		sigma_a = _sigma_a;
		sigma_s = _sigma_s;
		sigma_t = sigma_a + sigma_s;
	};
	bool diffuse_ray(const D3DXVECTOR3 & x, const D3DXVECTOR3 & n, const D3DXVECTOR3 &bx, const D3DXVECTOR3 & by, Ray & ray) const;
	bool refract_ray(const D3DXVECTOR3 & x, const D3DXVECTOR3 & v, const D3DXVECTOR3 & n, const D3DXVECTOR3 &bx, const D3DXVECTOR3 & by, const FLOAT & direction, Ray & ray, FLOAT & fresnel_scale, FLOAT _eta) const;
	bool sss_ray(const D3DXVECTOR3 & x, const D3DXVECTOR3 & v, const D3DXVECTOR3 & n, const D3DXVECTOR3 &bx,
		const D3DXVECTOR3 & by, const FLOAT & direction, const FLOAT & sigma_a, const FLOAT & sigma_s, Ray &ray, D3DXVECTOR3 & x_s, FLOAT & fresnel_scale, FLOAT & s_op, FLOAT scale) const;


	RNG rng;
	Texture * R;
	D3DXVECTOR3 specular;
	FLOAT eta, R0, emittance;
	// SSS p
	Color sigma_s;
	Color sigma_t;
	Color sigma_a;

	int type;
};


typedef std::vector<Material> materials_t;

#endif

