// s_texture.h
//  eNX`̃NX


#ifndef _S_TEXTURE_
#define _S_TEXTURE_	1

#include "s_color.h"
#include "DIB.h"	// ClassView ɂĒǉ܂B

class Texture 
{

public:

Color value(FLOAT u, FLOAT v) const {

		Color ret;
		
		if(fTextured){
//			FLOAT U = floorf(texture_w * u);
//			FLOAT V = floorf(texture_h * (1.0f - v));
			FLOAT U = texture_w * u;
			FLOAT V = texture_h * (1.0f - v);
			U = max(U, 0);U = min(U, texture_w - 1);
			V = max(V, 0);V = min(V, texture_h - 1);
			ret.x = map_r->cubic_at(U, V) / 255.0f;
			ret.y = map_g->cubic_at(U, V) / 255.0f;
			ret.z = map_b->cubic_at(U, V) / 255.0f;
			/*
			ret.x = *(map_r->at(U, V)) / 255.0f;
			ret.y = *(map_g->at(U, V)) / 255.0f;
			ret.z = *(map_b->at(U, V)) / 255.0f;
			*/
		} else {
			return rgb;
		};
		
		return ret;
	}
	void init_texture(gray_t * _r, gray_t * _g, gray_t * _b, LPSTR texname)
	{
		map_r = _r;
		map_g = _g;
		map_b = _b;
		texture_w = _r->width;
		texture_h = _r->height;
		fTextured = true;
		tex_name = texname;
	}
	void init_normalmap(gray_t * _r, gray_t * _g, gray_t * _b)
	{
		map_nx = _r;
		map_ny = _g;
		map_nz = _b;
		nw = _r->width;
		nh = _r->height;
		fNormalmap = true;
	}

	void init_bump(gray_t * _g)
	{
		map_bump = _g;
		bw = _g->width;
		bh = _g->height;
		fBumpmap = true;
	}

	Color rgb;
	bool fTextured, fNormalmap, fBumpmap;
	FLOAT texture_w, texture_h;
	FLOAT nw, nh, bw, bh;
	CString tex_name;
	gray_t * map_r, * map_g, * map_b;    //eNX`}bv
	gray_t * map_nx, * map_ny, * map_nz; //@}bv
	gray_t * map_bump;					 //Bump}bv
	Texture(){
	}
	Texture(Color _rgb){
		rgb = _rgb;
		fTextured = fNormalmap = fBumpmap = false;
		map_r = NULL;
		map_g = NULL;
		map_b = NULL;
	}

};


typedef std::vector<Texture> textures_t;


#endif

