//**********************************************************
// s_triangle.h
//  by g0307 2006
//**********************************************************

#ifndef _S_TRIANGLE_
#define _S_TRIANGLE_


#include "RNG.h"
#include "s_ray.h"
#include "s_material.h"

class Triangle;

struct HitRecord {

	FLOAT t;		   // CԂ܂ł̋
	D3DXVECTOR3 p;	   // ĈԂʒu
	D3DXVECTOR3 normal;// @	
	D3DXVECTOR3 bx, by;// normal̒xNg
	FLOAT		u, v;  // Ԃʒuuv Wl
	Material *  pMaterial; // ގf[^ւ̃|C^
	Triangle *  pObject;   // ԂIuWFNgւ̃|C^
	FLOAT		direction_sign;
	Ray			ray;
	FLOAT		shadow_d;

};

class Triangle {
	
public:
	RNG rng;
	void draw(CDC *pDC);
	
	bool hit(const Ray & ray, FLOAT tmin, FLOAT tmax, HitRecord & record) const;
	// @xNǧvZ
	D3DXVECTOR3 normal() const{
		static D3DXVECTOR3	normal;
		// @xNǧvZ
		D3DXVECTOR3 t0 = x2 - x1;
		D3DXVECTOR3 t1 = x3 - x1;
		D3DXVec3Cross((D3DXVECTOR3*)&normal, (D3DXVECTOR3*)&t1, (D3DXVECTOR3*)&t0);
		D3DXVec3Normalize((D3DXVECTOR3*)&normal, (D3DXVECTOR3*)&normal);
		return normal;
	}
	//***********************************************************
	// @xNg璼̐ڃxNgbx, byvZ
	//                 from lucille
	//***********************************************************
	void two_tangent_vector(const D3DXVECTOR3 &n, D3DXVECTOR3 &bx, D3DXVECTOR3 &by)
	{
		FLOAT e1,e2,e3,min;
		e1 = fabs(n.x);
		e2 = fabs(n.y);
		e3 = fabs(n.z);
		min = min(e1, min(e2, e3));
		
		if (min == e1) {
			bx.x =  0.0;
			bx.y = -n.z;
			bx.z =  n.y;
		} else if (min == e2) {
			bx.x = -n.z;
			bx.y =  0.0;
			bx.z =  n.x;
		} else if (min == e3) {
			bx.x = -n.y;
			bx.y =  n.x;
			bx.z =  0.0;
		}
		D3DXVec3Normalize(&bx, &bx);
		D3DXVec3Cross(&by, &bx, &n);
		D3DXVec3Normalize(&by, &by);
		
	}


	// i@ƒWxNǧvZj
	void init(){

		n = normal();
		two_tangent_vector(n, bx, by);
		
	};
	
	//***********************************************
	//  Op`̓__ɃTvO
	//***********************************************
	D3DXVECTOR3 sampling_point(){
		
		D3DXVECTOR3 p, bx, by;
		FLOAT w = rng.random(), t = (1.0 - w) * rng.random();
		bx = x3 - x1;
		by = x2 - x1;
		p = x1 + bx * w + by * t;
		return p;
	};
	D3DXVECTOR3 sampling_point(FLOAT w, FLOAT t){
		
		D3DXVECTOR3 p, bx, by;
		bx = x3 - x1;
		by = x2 - x1;
		p = x1 + bx * w + by * t;
		return p;
	};



	Triangle(){}
	Triangle(const D3DXVECTOR3 & _x1, const D3DXVECTOR3 & _x2, const D3DXVECTOR3 & _x3, Material * _pMaterial){
		x1 = _x1;
		x2 = _x2;
		x3 = _x3;
		n1.x = -1000;
		pMaterial = _pMaterial;
		init();
	}
	Triangle(const D3DXVECTOR3 & _x1, const D3DXVECTOR3 & _x2, const D3DXVECTOR3 & _x3, 
		const D3DXVECTOR2 & _uv1, const D3DXVECTOR2 & _uv2, const D3DXVECTOR2 & _uv3, Material * _pMaterial){
		x1 = _x1;
		x2 = _x2;
		x3 = _x3;
		uv1 = _uv1;
		uv2 = _uv2;
		uv3 = _uv3;
		n1.x=-1000;
		pMaterial = _pMaterial;
		init();
	}
	Triangle(
		const D3DXVECTOR3 & _x1, const D3DXVECTOR3 & _x2, const D3DXVECTOR3 & _x3, 
		const D3DXVECTOR2 & _uv1, const D3DXVECTOR2 & _uv2, const D3DXVECTOR2 & _uv3, 
		const D3DXVECTOR3 & _n1, const D3DXVECTOR3 & _n2, const D3DXVECTOR3 & _n3, 
		Material * _pMaterial){
		x1 = _x1;
		x2 = _x2;
		x3 = _x3;
		uv1 = _uv1;
		uv2 = _uv2;
		uv3 = _uv3;
		n1 = _n1;
		n2 = _n2;
		n3 = _n3;
		pMaterial = _pMaterial;
		init();
		//
		// UVWnł̌zpu, pv߂
		//
		FLOAT a, b, c,d;
		int i;
		for(i = 0; i < 3; i++){
			a = (uv2.y - uv1.y) * (x3[i] - x1[i]) - (uv3.y - uv1.y) * (x2[i] - x1[i]);
			b = (x2[i] - x1[i]) * (uv3.x - uv1.x) - (x3[i] - x1[i]) * (uv2.x - uv1.x);
			c = (uv2.x - uv1.x) * (uv3.y - uv1.y) - (uv3.x - uv1.x) * (uv2.y - uv1.y);
			d = -uv1.x * a - uv1.y * b - n1[i] * c;
			pu[i] = (-d-a) / c;
			pv[i] = (-d-b) / c;
		};
		D3DXVec3Normalize(&pu, &pu);
		D3DXVec3Normalize(&pv, &pv);
		D3DXVECTOR3 bn;
		D3DXVec3Cross(&bn, &pu, &pv);
		D3DXVec3Normalize(&bn, &bn);



	}
	Triangle(
		const D3DXVECTOR3 & _x1, const D3DXVECTOR3 & _x2, const D3DXVECTOR3 & _x3, 
		const D3DXVECTOR3 & _n1, const D3DXVECTOR3 & _n2, const D3DXVECTOR3 & _n3, 
		Material * _pMaterial){
		x1 = _x1;
		x2 = _x2;
		x3 = _x3;
		n1 = _n1;
		n2 = _n2;
		n3 = _n3;
		pMaterial = _pMaterial;
		init();
	}

	D3DXVECTOR3         x1, x2, x3;       // _f[^
	D3DXVECTOR3         n1, n2, n3;       // _f[^
	D3DXVECTOR2         uv1, uv2, uv3;    // _UVl
	D3DXVECTOR3         n, bx, by;     // WxNg
	Material *          pMaterial;	   // ގf[^ւ̃|C^
	unsigned short	    id;			   // mailbox p
	D3DXVECTOR3			pu, pv;

};

typedef Triangle * pTriangle;
typedef std::vector<pTriangle> ptriangles_t;

#endif
